/* include/SAMRAI_config.h.  Generated by configure.  */
/*
 * File:        SAMRAI_config.h.in
 * Package:     SAMRAI autoconf
 * Copyright:   (c) 1997-2005 The Regents of the University of California
 * Revision:    $Revision$
 * Modified:    $Date$
 * Description: SAMRAI configuration file
 */

/*
*************************************************************************
*                                                                       *
* IMPORTANT NOTE:  This file may be included in C source and/or         *
*                  header files.  Thus, all syntax, including           *
*                  comments must be standard C.                         *
*                                                                       *
*************************************************************************
*/

#ifndef included_SAMRAI_config
#define included_SAMRAI_config


/*
 * Flags to signal building optional types.
 */
#ifndef HAVE_BOOL
/* #undef HAVE_BOOL */
#endif

#ifndef HAVE_CHAR
/* #undef HAVE_CHAR */
#endif

#ifndef HAVE_FLOAT
/* #undef HAVE_FLOAT */
#endif

#ifndef HAVE_DCOMPLEX
/* #undef HAVE_DCOMPLEX */
#endif


/*
 * Building on a Sun Solaris machine.
 */

#ifndef HOST_OS_IS_SOLARIS
/* #undef HOST_OS_IS_SOLARIS */
#endif

/*
 * Header file defines and some special defines for AIX (yuck!)
 */

#ifndef _POSIX_SOURCE
/* #undef _POSIX_SOURCE */
#endif

#ifndef _ALL_SOURCE
/* #undef _ALL_SOURCE */
#endif

#ifndef _POWER
/* #undef _POWER */
#endif

/*
 * Sun and MSVC++ compiler do can not resolve bool and void*
 * methods.
 */
#if defined(__SUNPRO_CC) || defined(_MSC_VER)
#define LACKS_BOOL_VOID_RESOLUTION
#endif

#if defined(_MSC_VER)
#define LACKS_PROPER_MEMORY_HANDLER 1
#endif

/*
 * Architecture-specific bugs in system header files
 */

#ifndef LACKS_PROPER_XDR_HEADER
#define LACKS_PROPER_XDR_HEADER 1
#endif

/*
 * Some compilers require cmath to be included before the regular
 * C math.h and stdlib.h headers are brought in, otherwise
 * the compiler will get conflicting definitions for the functions.
 */
#if defined(__xlC__)
#define REQUIRES_CMATH 1
#endif

/*
 * general C++ compiler support
 */

#ifndef LACKS_NAMESPACE
/* #undef LACKS_NAMESPACE */
#endif

#ifndef LACKS_TEMPLATE_COMPLEX
/* #undef LACKS_TEMPLATE_COMPLEX */
#endif

#define STL_SSTREAM_HEADER_FILE <sstream>
#define LACKS_STRSTREAM

#ifndef IOMANIP_HEADER_FILE
#define IOMANIP_HEADER_FILE <iomanip>
#endif
#ifndef IOMANIP_HEADER_IS_BROKEN
/* #undef IOMANIP_HEADER_IS_BROKEN */
#endif

#ifndef IOSTREAM_HEADER_FILE
#define IOSTREAM_HEADER_FILE <iostream>
#endif
#ifndef IOSTREAM_HEADER_IS_BROKEN
/* #undef IOSTREAM_HEADER_IS_BROKEN */
#endif

#ifndef LACKS_IOMANIP_LEFT
/* #undef LACKS_IOMANIP_LEFT */
#endif

#ifndef LACKS_NEW_PLACEMENT_OPERATOR
/* #undef LACKS_NEW_PLACEMENT_OPERATOR */
#endif

/*
 * Control when template implementations (usually the .C file)
 * is included when compiling.
 *
 * This may be required by the compiler and compilation model (e.g.
 * implicit template instantiation models).
 */
#ifndef INCLUDE_TEMPLATE_IMPLEMENTATION
/* #undef INCLUDE_TEMPLATE_IMPLEMENTATION */
#endif

#ifndef LACKS_MEMBER_FUNCTION_SPECIALIZATION
/* #undef LACKS_MEMBER_FUNCTION_SPECIALIZATION */
#endif

#ifndef LACKS_STATIC_DATA_INSTANTIATION
/* #undef LACKS_STATIC_DATA_INSTANTIATION */
#endif

#ifndef LACKS_STANDARD_STATIC_DATA_SPECIALIZATION
/* #undef LACKS_STANDARD_STATIC_DATA_SPECIALIZATION */
#endif

#ifndef HAVE_ISNAN_TEMPLATE
/* #undef HAVE_ISNAN_TEMPLATE */
#endif


#ifndef LACKS_EXCEPTION_HANDLING
/* #undef LACKS_EXCEPTION_HANDLING */
#endif

#ifndef HAVE_PRAGMA_STATIC_DATA_SPECIALIZATION
/* #undef HAVE_PRAGMA_STATIC_DATA_SPECIALIZATION */
#endif

#ifndef HAVE_SPECIAL_COMPLEX_OSTREAM_INSTANTIATION
/* #undef HAVE_SPECIAL_COMPLEX_OSTREAM_INSTANTIATION */
#endif

#ifndef HAVE_SPECIAL_STRING_OSTREAM_INSTANTIATION
/* #undef HAVE_SPECIAL_STRING_OSTREAM_INSTANTIATION */
#endif

#ifndef RESTRICT_IS_BROKEN
/* #undef RESTRICT_IS_BROKEN */
#endif

#ifndef NAMESPACE_IS_BROKEN
/* #undef NAMESPACE_IS_BROKEN */
#endif

#ifndef HAVE_EXCEPTION_HANDLING
#define HAVE_EXCEPTION_HANDLING 1
#endif

#ifndef NAN_IS_BROKEN
#define NAN_IS_BROKEN 1
#endif

#ifndef FLT_SNAN_IS_BROKEN
#define FLT_SNAN_IS_BROKEN 1
#endif

#ifndef DBL_SNAN_IS_BROKEN
#define DBL_SNAN_IS_BROKEN 1
#endif

#ifndef FLT_MAX_IS_BROKEN
/* #undef FLT_MAX_IS_BROKEN */
#endif

#ifndef DBL_MAX_IS_BROKEN
/* #undef DBL_MAX_IS_BROKEN */
#endif

#ifndef OSTRINGSTREAM_TYPE_IS_BROKEN
/* #undef OSTRINGSTREAM_TYPE_IS_BROKEN */
#endif

#ifndef OSTRSTREAM_TYPE_IS_BROKEN
#define OSTRSTREAM_TYPE_IS_BROKEN 1
#endif

/*
 * X11 libraries
 */

#ifndef LACKS_X11
/* #undef LACKS_X11 */
#endif

/*
 * Fortran compiler name mangling
 */

/* #undef FORTRAN_DOUBLE_UNDERSCORE */
/* #undef FORTRAN_UNDERSCORE */
/* #undef FORTRAN_CAPS */
/* #undef FORTRAN_NO_UNDERSCORE */

/*
 * HDF5 common data format library
 */

#ifndef HAVE_HDF5
#define HAVE_HDF5 1
#endif

/*
 * Building with XDR
 */
#ifndef HAVE_XDR
/* #undef HAVE_XDR */
#endif

/*
 * MPI parallel message passing package
 */

#ifndef HAVE_MPI
#define HAVE_MPI 1
#endif

/*
 * Prevent inclusion of mpi C++ bindings on nirvana
 */
#ifdef HAVE_MPI
#define MPI_NO_CPPBIND
#endif

/*
 * KINSOL nonlinear solver package
 */

#ifndef HAVE_KINSOL
/* #undef HAVE_KINSOL */
#endif

/*
 * PVODE ODE solver package
 */

#ifndef HAVE_PVODE
/* #undef HAVE_PVODE */
#endif

/*
 * PETSc solvers package
 */

#ifndef HAVE_PETSC
#define HAVE_PETSC 1
#endif

/*
 * HYPRE preconditioning library
 */

#ifndef HAVE_HYPRE
/* #undef HAVE_HYPRE */
#endif

#ifndef HYPRE_SEQUENTIAL
/* #undef HYPRE_SEQUENTIAL */
#endif

/*
 * CUBES package
 */

#ifndef HAVE_CUBES
/* #undef HAVE_CUBES */
#endif

/*
 * Eleven package
 */

#ifndef HAVE_ELEVEN
/* #undef HAVE_ELEVEN */
#endif

/*
 * VAMPIR performance analysis package
 */

#ifndef HAVE_VAMPIR
/* #undef HAVE_VAMPIR */
#endif

/*
 * TAU performance analysis package
 */

#ifndef HAVE_TAU
/* #undef HAVE_TAU */
#endif

/*
 * SAMRAI debugging macros
 */

#ifndef DEBUG_NO_INLINE
/* #undef DEBUG_NO_INLINE */
#endif

#ifndef DEBUG_TRACE_CALLS
/* #undef DEBUG_TRACE_CALLS */
#endif

#ifndef DEBUG_CHECK_ASSERTIONS
/* #undef DEBUG_CHECK_ASSERTIONS */
#endif

#ifndef DEBUG_INITIALIZE_UNDEFINED
/* #undef DEBUG_INITIALIZE_UNDEFINED */
#endif

/*
 * A few things for the MSVC++ version.
 */
#ifdef _MSC_VER

/*
 * These need a test developed for autoconfig.  This is a bug
 * in the MSVC++ compiler
 */
#define LACKS_NAMESPACE_IN_DECLARE

/*
 * Move this bad stuff to the utility class, not POSIX
 */
#define drand48() ((double)rand()/(double)RAND_MAX)
/*
 * This is not correct, the range is wrong, need to find
 * a better solution
 */
#define mrand48() (rand())

/*
 * Some IEEE stuff is not under the normal names.
 *
 */
#define isnan _isnan

#endif

/*
 * Set the depracated level, depracated features from
 * release greater than this number will be included.
 *
 */
#define INCLUDE_DEPRACATED 1

#endif
