# aclocal.m4 generated automatically by aclocal 1.5

# Copyright 1996, 1997, 1998, 1999, 2000, 2001
# Free Software Foundation, Inc.
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.

# Do all the work for Automake.  This macro actually does too much --
# some checks are only needed if your package does certain things.
# But this isn't really a big deal.

# serial 5

# There are a few dirty hacks below to avoid letting `AC_PROG_CC' be
# written in clear, in which case automake, when reading aclocal.m4,
# will think it sees a *use*, and therefore will trigger all it's
# C support machinery.  Also note that it means that autoscan, seeing
# CC etc. in the Makefile, will ask for an AC_PROG_CC use...


# We require 2.13 because we rely on SHELL being computed by configure.
AC_PREREQ([2.13])

# AC_PROVIDE_IFELSE(MACRO-NAME, IF-PROVIDED, IF-NOT-PROVIDED)
# -----------------------------------------------------------
# If MACRO-NAME is provided do IF-PROVIDED, else IF-NOT-PROVIDED.
# The purpose of this macro is to provide the user with a means to
# check macros which are provided without letting her know how the
# information is coded.
# If this macro is not defined by Autoconf, define it here.
ifdef([AC_PROVIDE_IFELSE],
      [],
      [define([AC_PROVIDE_IFELSE],
              [ifdef([AC_PROVIDE_$1],
                     [$2], [$3])])])


# AM_INIT_AUTOMAKE(PACKAGE,VERSION, [NO-DEFINE])
# ----------------------------------------------
AC_DEFUN([AM_INIT_AUTOMAKE],
[AC_REQUIRE([AC_PROG_INSTALL])dnl
# test to see if srcdir already configured
if test "`CDPATH=:; cd $srcdir && pwd`" != "`pwd`" &&
   test -f $srcdir/config.status; then
  AC_MSG_ERROR([source directory already configured; run \"make distclean\" there first])
fi

# Define the identity of the package.
PACKAGE=$1
AC_SUBST(PACKAGE)dnl
VERSION=$2
AC_SUBST(VERSION)dnl
ifelse([$3],,
[AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE", [Name of package])
AC_DEFINE_UNQUOTED(VERSION, "$VERSION", [Version number of package])])

# Autoconf 2.50 wants to disallow AM_ names.  We explicitly allow
# the ones we care about.
ifdef([m4_pattern_allow],
      [m4_pattern_allow([^AM_[A-Z]+FLAGS])])dnl

# Autoconf 2.50 always computes EXEEXT.  However we need to be
# compatible with 2.13, for now.  So we always define EXEEXT, but we
# don't compute it.
AC_SUBST(EXEEXT)
# Similar for OBJEXT -- only we only use OBJEXT if the user actually
# requests that it be used.  This is a bit dumb.
: ${OBJEXT=o}
AC_SUBST(OBJEXT)

# Some tools Automake needs.
AC_REQUIRE([AM_SANITY_CHECK])dnl
AC_REQUIRE([AC_ARG_PROGRAM])dnl
AM_MISSING_PROG(ACLOCAL, aclocal)
AM_MISSING_PROG(AUTOCONF, autoconf)
AM_MISSING_PROG(AUTOMAKE, automake)
AM_MISSING_PROG(AUTOHEADER, autoheader)
AM_MISSING_PROG(MAKEINFO, makeinfo)
AM_MISSING_PROG(AMTAR, tar)
AM_PROG_INSTALL_SH
AM_PROG_INSTALL_STRIP
# We need awk for the "check" target.  The system "awk" is bad on
# some platforms.
AC_REQUIRE([AC_PROG_AWK])dnl
AC_REQUIRE([AC_PROG_MAKE_SET])dnl
AC_REQUIRE([AM_DEP_TRACK])dnl
AC_REQUIRE([AM_SET_DEPDIR])dnl
AC_PROVIDE_IFELSE([AC_PROG_][CC],
                  [_AM_DEPENDENCIES(CC)],
                  [define([AC_PROG_][CC],
                          defn([AC_PROG_][CC])[_AM_DEPENDENCIES(CC)])])dnl
AC_PROVIDE_IFELSE([AC_PROG_][CXX],
                  [_AM_DEPENDENCIES(CXX)],
                  [define([AC_PROG_][CXX],
                          defn([AC_PROG_][CXX])[_AM_DEPENDENCIES(CXX)])])dnl
])

#
# Check to make sure that the build environment is sane.
#

# serial 3

# AM_SANITY_CHECK
# ---------------
AC_DEFUN([AM_SANITY_CHECK],
[AC_MSG_CHECKING([whether build environment is sane])
# Just in case
sleep 1
echo timestamp > conftest.file
# Do `set' in a subshell so we don't clobber the current shell's
# arguments.  Must try -L first in case configure is actually a
# symlink; some systems play weird games with the mod time of symlinks
# (eg FreeBSD returns the mod time of the symlink's containing
# directory).
if (
   set X `ls -Lt $srcdir/configure conftest.file 2> /dev/null`
   if test "$[*]" = "X"; then
      # -L didn't work.
      set X `ls -t $srcdir/configure conftest.file`
   fi
   rm -f conftest.file
   if test "$[*]" != "X $srcdir/configure conftest.file" \
      && test "$[*]" != "X conftest.file $srcdir/configure"; then

      # If neither matched, then we have a broken ls.  This can happen
      # if, for instance, CONFIG_SHELL is bash and it inherits a
      # broken ls alias from the environment.  This has actually
      # happened.  Such a system could not be considered "sane".
      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
alias in your environment])
   fi

   test "$[2]" = conftest.file
   )
then
   # Ok.
   :
else
   AC_MSG_ERROR([newly created file is older than distributed files!
Check your system clock])
fi
AC_MSG_RESULT(yes)])


# serial 2

# AM_MISSING_PROG(NAME, PROGRAM)
# ------------------------------
AC_DEFUN([AM_MISSING_PROG],
[AC_REQUIRE([AM_MISSING_HAS_RUN])
$1=${$1-"${am_missing_run}$2"}
AC_SUBST($1)])


# AM_MISSING_HAS_RUN
# ------------------
# Define MISSING if not defined so far and test if it supports --run.
# If it does, set am_missing_run to use it, otherwise, to nothing.
AC_DEFUN([AM_MISSING_HAS_RUN],
[AC_REQUIRE([AM_AUX_DIR_EXPAND])dnl
test x"${MISSING+set}" = xset || MISSING="\${SHELL} $am_aux_dir/missing"
# Use eval to expand $SHELL
if eval "$MISSING --run true"; then
  am_missing_run="$MISSING --run "
else
  am_missing_run=
  am_backtick='`'
  AC_MSG_WARN([${am_backtick}missing' script is too old or missing])
fi
])

# AM_AUX_DIR_EXPAND

# For projects using AC_CONFIG_AUX_DIR([foo]), Autoconf sets
# $ac_aux_dir to `$srcdir/foo'.  In other projects, it is set to
# `$srcdir', `$srcdir/..', or `$srcdir/../..'.
#
# Of course, Automake must honor this variable whenever it calls a
# tool from the auxiliary directory.  The problem is that $srcdir (and
# therefore $ac_aux_dir as well) can be either absolute or relative,
# depending on how configure is run.  This is pretty annoying, since
# it makes $ac_aux_dir quite unusable in subdirectories: in the top
# source directory, any form will work fine, but in subdirectories a
# relative path needs to be adjusted first.
#
# $ac_aux_dir/missing
#    fails when called from a subdirectory if $ac_aux_dir is relative
# $top_srcdir/$ac_aux_dir/missing
#    fails if $ac_aux_dir is absolute,
#    fails when called from a subdirectory in a VPATH build with
#          a relative $ac_aux_dir
#
# The reason of the latter failure is that $top_srcdir and $ac_aux_dir
# are both prefixed by $srcdir.  In an in-source build this is usually
# harmless because $srcdir is `.', but things will broke when you
# start a VPATH build or use an absolute $srcdir.
#
# So we could use something similar to $top_srcdir/$ac_aux_dir/missing,
# iff we strip the leading $srcdir from $ac_aux_dir.  That would be:
#   am_aux_dir='\$(top_srcdir)/'`expr "$ac_aux_dir" : "$srcdir//*\(.*\)"`
# and then we would define $MISSING as
#   MISSING="\${SHELL} $am_aux_dir/missing"
# This will work as long as MISSING is not called from configure, because
# unfortunately $(top_srcdir) has no meaning in configure.
# However there are other variables, like CC, which are often used in
# configure, and could therefore not use this "fixed" $ac_aux_dir.
#
# Another solution, used here, is to always expand $ac_aux_dir to an
# absolute PATH.  The drawback is that using absolute paths prevent a
# configured tree to be moved without reconfiguration.

AC_DEFUN([AM_AUX_DIR_EXPAND], [
# expand $ac_aux_dir to an absolute path
am_aux_dir=`CDPATH=:; cd $ac_aux_dir && pwd`
])

# AM_PROG_INSTALL_SH
# ------------------
# Define $install_sh.
AC_DEFUN([AM_PROG_INSTALL_SH],
[AC_REQUIRE([AM_AUX_DIR_EXPAND])dnl
install_sh=${install_sh-"$am_aux_dir/install-sh"}
AC_SUBST(install_sh)])

# One issue with vendor `install' (even GNU) is that you can't
# specify the program used to strip binaries.  This is especially
# annoying in cross-compiling environments, where the build's strip
# is unlikely to handle the host's binaries.
# Fortunately install-sh will honor a STRIPPROG variable, so we
# always use install-sh in `make install-strip', and initialize
# STRIPPROG with the value of the STRIP variable (set by the user).
AC_DEFUN([AM_PROG_INSTALL_STRIP],
[AC_REQUIRE([AM_PROG_INSTALL_SH])dnl
INSTALL_STRIP_PROGRAM="\${SHELL} \$(install_sh) -c -s"
AC_SUBST([INSTALL_STRIP_PROGRAM])])

# serial 4						-*- Autoconf -*-



# There are a few dirty hacks below to avoid letting `AC_PROG_CC' be
# written in clear, in which case automake, when reading aclocal.m4,
# will think it sees a *use*, and therefore will trigger all it's
# C support machinery.  Also note that it means that autoscan, seeing
# CC etc. in the Makefile, will ask for an AC_PROG_CC use...



# _AM_DEPENDENCIES(NAME)
# ---------------------
# See how the compiler implements dependency checking.
# NAME is "CC", "CXX" or "OBJC".
# We try a few techniques and use that to set a single cache variable.
#
# We don't AC_REQUIRE the corresponding AC_PROG_CC since the latter was
# modified to invoke _AM_DEPENDENCIES(CC); we would have a circular
# dependency, and given that the user is not expected to run this macro,
# just rely on AC_PROG_CC.
AC_DEFUN([_AM_DEPENDENCIES],
[AC_REQUIRE([AM_SET_DEPDIR])dnl
AC_REQUIRE([AM_OUTPUT_DEPENDENCY_COMMANDS])dnl
AC_REQUIRE([AM_MAKE_INCLUDE])dnl
AC_REQUIRE([AM_DEP_TRACK])dnl

ifelse([$1], CC,   [depcc="$CC"   am_compiler_list=],
       [$1], CXX,  [depcc="$CXX"  am_compiler_list=],
       [$1], OBJC, [depcc="$OBJC" am_compiler_list='gcc3 gcc']
       [$1], GCJ,  [depcc="$GCJ"  am_compiler_list='gcc3 gcc'],
                   [depcc="$$1"   am_compiler_list=])

AC_CACHE_CHECK([dependency style of $depcc],
               [am_cv_$1_dependencies_compiler_type],
[if test -z "$AMDEP_TRUE" && test -f "$am_depcomp"; then
  # We make a subdir and do the tests there.  Otherwise we can end up
  # making bogus files that we don't know about and never remove.  For
  # instance it was reported that on HP-UX the gcc test will end up
  # making a dummy file named `D' -- because `-MD' means `put the output
  # in D'.
  mkdir conftest.dir
  # Copy depcomp to subdir because otherwise we won't find it if we're
  # using a relative directory.
  cp "$am_depcomp" conftest.dir
  cd conftest.dir

  am_cv_$1_dependencies_compiler_type=none
  if test "$am_compiler_list" = ""; then
     am_compiler_list=`sed -n ['s/^#*\([a-zA-Z0-9]*\))$/\1/p'] < ./depcomp`
  fi
  for depmode in $am_compiler_list; do
    # We need to recreate these files for each test, as the compiler may
    # overwrite some of them when testing with obscure command lines.
    # This happens at least with the AIX C compiler.
    echo '#include "conftest.h"' > conftest.c
    echo 'int i;' > conftest.h
    echo "${am__include} ${am__quote}conftest.Po${am__quote}" > confmf

    case $depmode in
    nosideeffect)
      # after this tag, mechanisms are not by side-effect, so they'll
      # only be used when explicitly requested
      if test "x$enable_dependency_tracking" = xyes; then
	continue
      else
	break
      fi
      ;;
    none) break ;;
    esac
    # We check with `-c' and `-o' for the sake of the "dashmstdout"
    # mode.  It turns out that the SunPro C++ compiler does not properly
    # handle `-M -o', and we need to detect this.
    if depmode=$depmode \
       source=conftest.c object=conftest.o \
       depfile=conftest.Po tmpdepfile=conftest.TPo \
       $SHELL ./depcomp $depcc -c conftest.c -o conftest.o >/dev/null 2>&1 &&
       grep conftest.h conftest.Po > /dev/null 2>&1 &&
       ${MAKE-make} -s -f confmf > /dev/null 2>&1; then
      am_cv_$1_dependencies_compiler_type=$depmode
      break
    fi
  done

  cd ..
  rm -rf conftest.dir
else
  am_cv_$1_dependencies_compiler_type=none
fi
])
$1DEPMODE="depmode=$am_cv_$1_dependencies_compiler_type"
AC_SUBST([$1DEPMODE])
])


# AM_SET_DEPDIR
# -------------
# Choose a directory name for dependency files.
# This macro is AC_REQUIREd in _AM_DEPENDENCIES
AC_DEFUN([AM_SET_DEPDIR],
[rm -f .deps 2>/dev/null
mkdir .deps 2>/dev/null
if test -d .deps; then
  DEPDIR=.deps
else
  # MS-DOS does not allow filenames that begin with a dot.
  DEPDIR=_deps
fi
rmdir .deps 2>/dev/null
AC_SUBST(DEPDIR)
])


# AM_DEP_TRACK
# ------------
AC_DEFUN([AM_DEP_TRACK],
[AC_ARG_ENABLE(dependency-tracking,
[  --disable-dependency-tracking Speeds up one-time builds
  --enable-dependency-tracking  Do not reject slow dependency extractors])
if test "x$enable_dependency_tracking" != xno; then
  am_depcomp="$ac_aux_dir/depcomp"
  AMDEPBACKSLASH='\'
fi
AM_CONDITIONAL([AMDEP], [test "x$enable_dependency_tracking" != xno])
pushdef([subst], defn([AC_SUBST]))
subst(AMDEPBACKSLASH)
popdef([subst])
])

# Generate code to set up dependency tracking.
# This macro should only be invoked once -- use via AC_REQUIRE.
# Usage:
# AM_OUTPUT_DEPENDENCY_COMMANDS

#
# This code is only required when automatic dependency tracking
# is enabled.  FIXME.  This creates each `.P' file that we will
# need in order to bootstrap the dependency handling code.
AC_DEFUN([AM_OUTPUT_DEPENDENCY_COMMANDS],[
AC_OUTPUT_COMMANDS([
test x"$AMDEP_TRUE" != x"" ||
for mf in $CONFIG_FILES; do
  case "$mf" in
  Makefile) dirpart=.;;
  */Makefile) dirpart=`echo "$mf" | sed -e 's|/[^/]*$||'`;;
  *) continue;;
  esac
  grep '^DEP_FILES *= *[^ #]' < "$mf" > /dev/null || continue
  # Extract the definition of DEP_FILES from the Makefile without
  # running `make'.
  DEPDIR=`sed -n -e '/^DEPDIR = / s///p' < "$mf"`
  test -z "$DEPDIR" && continue
  # When using ansi2knr, U may be empty or an underscore; expand it
  U=`sed -n -e '/^U = / s///p' < "$mf"`
  test -d "$dirpart/$DEPDIR" || mkdir "$dirpart/$DEPDIR"
  # We invoke sed twice because it is the simplest approach to
  # changing $(DEPDIR) to its actual value in the expansion.
  for file in `sed -n -e '
    /^DEP_FILES = .*\\\\$/ {
      s/^DEP_FILES = //
      :loop
	s/\\\\$//
	p
	n
	/\\\\$/ b loop
      p
    }
    /^DEP_FILES = / s/^DEP_FILES = //p' < "$mf" | \
       sed -e 's/\$(DEPDIR)/'"$DEPDIR"'/g' -e 's/\$U/'"$U"'/g'`; do
    # Make sure the directory exists.
    test -f "$dirpart/$file" && continue
    fdir=`echo "$file" | sed -e 's|/[^/]*$||'`
    $ac_aux_dir/mkinstalldirs "$dirpart/$fdir" > /dev/null 2>&1
    # echo "creating $dirpart/$file"
    echo '# dummy' > "$dirpart/$file"
  done
done
], [AMDEP_TRUE="$AMDEP_TRUE"
ac_aux_dir="$ac_aux_dir"])])

# AM_MAKE_INCLUDE()
# -----------------
# Check to see how make treats includes.
AC_DEFUN([AM_MAKE_INCLUDE],
[am_make=${MAKE-make}
cat > confinc << 'END'
doit:
	@echo done
END
# If we don't find an include directive, just comment out the code.
AC_MSG_CHECKING([for style of include used by $am_make])
am__include='#'
am__quote=
_am_result=none
# First try GNU make style include.
echo "include confinc" > confmf
# We grep out `Entering directory' and `Leaving directory'
# messages which can occur if `w' ends up in MAKEFLAGS.
# In particular we don't look at `^make:' because GNU make might
# be invoked under some other name (usually "gmake"), in which
# case it prints its new name instead of `make'.
if test "`$am_make -s -f confmf 2> /dev/null | fgrep -v 'ing directory'`" = "done"; then
   am__include=include
   am__quote=
   _am_result=GNU
fi
# Now try BSD make style include.
if test "$am__include" = "#"; then
   echo '.include "confinc"' > confmf
   if test "`$am_make -s -f confmf 2> /dev/null`" = "done"; then
      am__include=.include
      am__quote='"'
      _am_result=BSD
   fi
fi
AC_SUBST(am__include)
AC_SUBST(am__quote)
AC_MSG_RESULT($_am_result)
rm -f confinc confmf
])

# serial 3

# AM_CONDITIONAL(NAME, SHELL-CONDITION)
# -------------------------------------
# Define a conditional.
#
# FIXME: Once using 2.50, use this:
# m4_match([$1], [^TRUE\|FALSE$], [AC_FATAL([$0: invalid condition: $1])])dnl
AC_DEFUN([AM_CONDITIONAL],
[ifelse([$1], [TRUE],
        [errprint(__file__:__line__: [$0: invalid condition: $1
])dnl
m4exit(1)])dnl
ifelse([$1], [FALSE],
       [errprint(__file__:__line__: [$0: invalid condition: $1
])dnl
m4exit(1)])dnl
AC_SUBST([$1_TRUE])
AC_SUBST([$1_FALSE])
if $2; then
  $1_TRUE=
  $1_FALSE='#'
else
  $1_TRUE='#'
  $1_FALSE=
fi])

# Like AC_CONFIG_HEADER, but automatically create stamp file.

# serial 3

# When config.status generates a header, we must update the stamp-h file.
# This file resides in the same directory as the config header
# that is generated.  We must strip everything past the first ":",
# and everything past the last "/".

AC_PREREQ([2.12])

AC_DEFUN([AM_CONFIG_HEADER],
[ifdef([AC_FOREACH],dnl
	 [dnl init our file count if it isn't already
	 m4_ifndef([_AM_Config_Header_Index], m4_define([_AM_Config_Header_Index], [0]))
	 dnl prepare to store our destination file list for use in config.status
	 AC_FOREACH([_AM_File], [$1],
		    [m4_pushdef([_AM_Dest], m4_patsubst(_AM_File, [:.*]))
		    m4_define([_AM_Config_Header_Index], m4_incr(_AM_Config_Header_Index))
		    dnl and add it to the list of files AC keeps track of, along
		    dnl with our hook
		    AC_CONFIG_HEADERS(_AM_File,
dnl COMMANDS, [, INIT-CMDS]
[# update the timestamp
echo timestamp >"AS_ESCAPE(_AM_DIRNAME(]_AM_Dest[))/stamp-h]_AM_Config_Header_Index["
][$2]m4_ifval([$3], [, [$3]]))dnl AC_CONFIG_HEADERS
		    m4_popdef([_AM_Dest])])],dnl
[AC_CONFIG_HEADER([$1])
  AC_OUTPUT_COMMANDS(
   ifelse(patsubst([$1], [[^ ]], []),
	  [],
	  [test -z "$CONFIG_HEADERS" || echo timestamp >dnl
	   patsubst([$1], [^\([^:]*/\)?.*], [\1])stamp-h]),dnl
[am_indx=1
for am_file in $1; do
  case " \$CONFIG_HEADERS " in
  *" \$am_file "*)
    am_dir=\`echo \$am_file |sed 's%:.*%%;s%[^/]*\$%%'\`
    if test -n "\$am_dir"; then
      am_tmpdir=\`echo \$am_dir |sed 's%^\(/*\).*\$%\1%'\`
      for am_subdir in \`echo \$am_dir |sed 's%/% %'\`; do
        am_tmpdir=\$am_tmpdir\$am_subdir/
        if test ! -d \$am_tmpdir; then
          mkdir \$am_tmpdir
        fi
      done
    fi
    echo timestamp > "\$am_dir"stamp-h\$am_indx
    ;;
  esac
  am_indx=\`expr \$am_indx + 1\`
done])
])]) # AM_CONFIG_HEADER

# _AM_DIRNAME(PATH)
# -----------------
# Like AS_DIRNAME, only do it during macro expansion
AC_DEFUN([_AM_DIRNAME],
       [m4_if(m4_regexp([$1], [^.*[^/]//*[^/][^/]*/*$]), -1,
	      m4_if(m4_regexp([$1], [^//\([^/]\|$\)]), -1,
		    m4_if(m4_regexp([$1], [^/.*]), -1,
			  [.],
			  m4_patsubst([$1], [^\(/\).*], [\1])),
		    m4_patsubst([$1], [^\(//\)\([^/].*\|$\)], [\1])),
	      m4_patsubst([$1], [^\(.*[^/]\)//*[^/][^/]*/*$], [\1]))[]dnl
]) # _AM_DIRNAME

AC_DEFUN(BTNG_AC_LOG,[echo "configure:__oline__:" $1 >&AC_FD_CC])

AC_DEFUN(BTNG_AC_LOG_VAR,[
dnl arg1 is list of variables to log.
dnl arg2 (optional) is a label.
dnl ifelse($2,,define(btng_log_label),define(btng_log_label,$2: ))
define([btng_log_label],ifelse($2,,,[$2: ]))
btng_log_vars="$1"
for btng_log_vars_index in $btng_log_vars ; do
  BTNG_AC_LOG("btng_log_label$btng_log_vars_index is '`eval echo \\\"\$\{$btng_log_vars_index\}\\\"`'")
done
undefine([btng_log_label])
])

dnl $Id: compiler-id.m4,v 1.8 2001/10/22 18:39:23 gunney Exp $

dnl Determines which compiler is being used.
dnl This check uses the compiler behavior when possible.
dnl For some compiler, we resort to a best guess,
dnl because we do not know a foolproof way to get the info.


dnl Simple wrappers to allow using BTNG_INFO_CXX_ID_NAMES and
dnl BTNG_INFO_CC_ID_NAMES without arguments.
dnl The names CC_ID and CC_VERSION are used for the C compiler id and version.
dnl The names CXX_ID and CXX_VERSION are used for the C++ compiler id and version.
AC_DEFUN(BTNG_INFO_CXX_ID,[
  BTNG_INFO_CXX_ID_NAMES(CXX_ID,CXX_VERSION)
])
AC_DEFUN(BTNG_INFO_CC_ID,[
  BTNG_INFO_CC_ID_NAMES(CC_ID,CC_VERSION)
])
AC_DEFUN(BTNG_INFO_CC_CXX_ID,[
  AC_REQUIRE([BTNG_INFO_CC_ID])
  AC_REQUIRE([BTNG_INFO_CXX_ID])
])


dnl BTNG_INFO_CXX_ID and BTNG_INFO_C_ID determine which C or C++ compiler
dnl is being used.
# Set the variables CXX_ID or C_ID as follows:
# Gnu		-> gnu
# SUNWspro	-> sunpro
# Dec		-> dec
# KCC		-> kai
# SGI		-> sgi
# IBM		-> ibm


AC_DEFUN(BTNG_INFO_CXX_ID_NAMES,
dnl Arguments are:
dnl 1. Name of variable to set to the ID string.
dnl 2. Name of variable to set to the version number.
[
# Start macro BTNG_INFO_CXX_ID_NAMES
  AC_REQUIRE([AC_PROG_CXXCPP])
  AC_LANG_SAVE
  AC_LANG_CPLUSPLUS
  BTNG_AC_LOG(CXXP is $CXX)
  BTNG_AC_LOG(CXXCPP is $CXXCPP)

  $1=unknown
  $2=unknown

dnl Do not change the following chain of if blocks into a case statement.
dnl We may eventually have a compiler that must be tested in a different
dnl method


  # Check if it is a Sun compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is sunpro)
changequote(BEG,END)
    AC_EGREP_CPP(^0x[0-9]+,__SUNPRO_CC,
changequote([,])
      $1=sunpro
      # SUN compiler defines __SUNPRO_CC to the version number.
      echo __SUNPRO_CC > conftest.C
      $2=`${CXXCPP} conftest.C | sed -n 2p`
      rm -f conftest.C
    )
  fi


  # Check if it is a GNU compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is gnu)
    AC_EGREP_CPP(^yes,
#ifdef __GNUC__
yes;
#endif
,
    $1=gnu
changequote(BEG,END)
    $2=`$CXX --version | sed 's/^[[^0-9]]*//'`
changequote([,])
    )
  fi


  # Check if it is a DEC compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is dec)
    AC_EGREP_CPP(^1,__DECCXX,
      $1=dec
      # DEC compiler defines __DECCXX_VER to the version number.
      echo __DECCXX_VER > conftest.C
      $2=`${CXXCPP} conftest.C | sed -n 2p`
      rm -f conftest.C
    )
  fi


  # Check if it is a KAI compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is kai)
    AC_EGREP_CPP(^1,__KCC,
      $1=kai
      # KCC compiler defines __KCC_VERSION to the version number.
      echo __KCC_VERSION > conftest.C
      $2=`${CXXCPP} conftest.C | sed -n 2p`
      rm -f conftest.C
    )
  fi


  # Check if it is a SGI compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is sgi)
    AC_EGREP_CPP(^1,__sgi,
      $1=sgi
      # SGI compiler defines _COMPILER_VERSION to the version number.
      echo _COMPILER_VERSION > conftest.C
      $2=`${CXXCPP} conftest.C | sed /^\\#/d`
      rm -f conftest.C
    )
  fi


  # Check if it is a IBM compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is ibm)
    AC_EGREP_CPP(^1,_AIX,
      $1=ibm
      # I do not know how to determine version for this compiler.
    )
  fi


  AC_LANG_RESTORE
  BTNG_AC_LOG_VAR(CXX_ID CXX_VERSION)
# End macro BTNG_INFO_CXX_ID_NAMES
])





AC_DEFUN(BTNG_INFO_CC_ID_NAMES,
dnl Arguments are:
dnl 1. Name of variable to set to the ID string.
dnl 2. Name of variable to set to the version number.
[
# Start macro BTNG_INFO_CC_ID_NAMES
  AC_REQUIRE([AC_PROG_CPP])
  AC_LANG_SAVE
  AC_LANG_C
  BTNG_AC_LOG(CC is $CC)
  BTNG_AC_LOG(CPP is $CPP)

  $1=unknown
  $2=unknown

dnl Do not change the following chain of if blocks into a case statement.
dnl We may eventually have a compiler that must be tested in a different
dnl method


  # Check if it is a Sun compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is sunpro)
changequote(BEG,END)
    AC_EGREP_CPP(^ 0x[0-9]+,__SUNPRO_C,
changequote([,])
      $1=sunpro
      # SUN compiler defines __SUNPRO_C to the version number.
      echo __SUNPRO_C > conftest.c
      $2=`${CPP} ${CPPFLAGS} conftest.c | sed -n -e 's/^ //' -e 2p`
      rm -f conftest.c
    )
  fi


  # Check if it is a GNU compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is gnu)
    AC_EGREP_CPP(^yes,
#ifdef __GNUC__
yes;
#endif
,
    $1=gnu
changequote(BEG,END)
    $2=`${CC} --version | sed 's/^[[^0-9]]*//'`
changequote([,])
    )
  fi


  # Check if it is a DEC compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is dec)
    AC_EGREP_CPP(^ 1,__DECC,
      $1=dec
      # DEC compiler defines __DECC_VER to the version number.
      echo __DECC_VER > conftest.c
      $2=`${CPP} ${CPPFLAGS} conftest.c | sed -n -e 's/^ //' -e 2p`
      rm -f conftest.c
    )
  fi


  # Check if it is a KAI compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is kai)
    AC_EGREP_CPP(^1,__KCC,
      $1=kai
      # KCC compiler defines __KCC_VERSION to the version number.
      echo __KCC_VERSION > conftest.c
      $2=`${CPP} ${CPPFLAGS} conftest.c | sed -n 2p`
      rm -f conftest.c
    )
  fi


  # Check if it is a SGI compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is sgi)
    AC_EGREP_CPP(^1,__sgi,
      $1=sgi
      # SGI compiler defines _COMPILER_VERSION to the version number.
      echo _COMPILER_VERSION > conftest.c
      $2=`${CPP} ${CPPFLAGS} conftest.c | sed /^\\#/d`
      rm -f conftest.c
    )
  fi


  # Check if it is a IBM compiler.
  if test $$1 = unknown; then
    BTNG_AC_LOG(checking if $CXX is ibm)
    if echo "$host_os" | grep "aix" >/dev/null ; then
      # The wretched IBM shell does not eval correctly,
      # so we have to help it with a pre-eval eval statement.
      ac_cpp=`eval "echo $ac_cpp"`
      save_ac_cpp=$ac_cpp
      BTNG_AC_LOG(ac_cpp is temporarily set to $ac_cpp)
    else
      save_ac_cpp=
    fi
    BTNG_AC_LOG(ac_cpp is $ac_cpp)
    AC_EGREP_CPP(^1,_AIX,
      $1=ibm
      # I do not know how to determine version for this compiler.
    )
    test "$save_ac_cpp" && ac_cpp=$save_ac_cpp
    BTNG_AC_LOG(ac_cpp is restored to $ac_cpp)
  fi


  AC_LANG_RESTORE
  BTNG_AC_LOG_VAR(CC_ID CC_VERSION)
# End macro BTNG_INFO_CC_ID_NAMES
])

dnl File arg-with-environment.m4
dnl Written by Brian T.N. Gunney
dnl gunneyb@llnl.gov
dnl $Id: arg-with-environment.m4,v 1.17 2001/10/22 21:05:45 gunney Exp $



AC_DEFUN(BTNG_ARG_WITH_ENV_WRAPPER,[
dnl This is a high-level macro similar to AC_ARG_WITH but it does
dnl   a few extra things.
dnl
dnl It is meant for setting a shell variable using either the
dnl   --with-feature configure flag or by setting a shell variable
dnl   in the environment.  But its primary goal it to set or unset
dnl   the shell variable (arg2).
dnl
dnl One of several things can happen to the shell variable
dnl   when you use this macro, depending first on the configure
dnl   option issued:
dnl   |
dnl   `-- no option given
dnl   |   `-- leave shell variable alone, regardless of whether
dnl   |       it is set (This is how you avoid
dnl   |       having to use the configure option, such as in
dnl   |       running the check rule by automake.)
dnl   `-- with-feature=no or without-feature
dnl   |   `-- unset shell variable, regardless of whether it is set
dnl   `-- with-feature=string
dnl   |   `-- set shell variable to the string
dnl   `-- with-feature or with-feature=yes
dnl       `-- if shell variable already set
dnl       |   `-- leave it a lone
dnl       `-- else if developer gave optional arg4
dnl       |   `-- execute optional arg4 to set shell variable
dnl       `-- else
dnl           `-- set shell variable to blank
dnl
dnl One of two things can happen to the with_feature variable,
dnl   assuming the developer does not change it using arg4.
dnl   `-- no option given
dnl       `-- with_feature is unset
dnl   `-- one of the options referring to "feature" is given
dnl       `-- with_feature is set
dnl
dnl In addition to running AC_ARG_WITH and caching the result, it:
dnl   Allows the variable to be set by the environment.  This is
dnl     for avoiding having to manually issue configure options
dnl     or when manual configure options are not permissible, as
dnl     in running "make check".  The environment variable is
dnl     checked if the --with-something=something_else option
dnl     is not given or given without the equal sign.
dnl   Lets you specify command to run if --with-blah is issued
dnl     without the equal sign or not issued at all.  In this
dnl     case, the environment variable is consulted.  An unset
dnl     environment variable is the same as --without-bla.  A set
dnl     variable is the same as --with-blah=$value.  If $value is an
dnl     empty string, runs optional command (arg5) to set it.
dnl   Lets you specify command (arg4) to check the value chosen
dnl     to make it is good, before caching it.
dnl The arguments to this macro are:
dnl   1: Name of what is being sought (the first argument in
dnl     AC_ARG_WITH).
dnl   2: Name of variable to set (also name of environment variable
dnl      to look for if configure option is not issued).
dnl   3(optional): Help message.  A generic message is provided if
dnl     this argument is empty.
dnl   4(optional): Commands to run if configure flag is not specific
dnl     and environment variable is not set.  These commands are
dnl     run if with_blah is "yes" or "".  They should set or unset
dnl     the variable named in arg2, depending on what you want
dnl     the default behavior to be in these cases.
dnl   5(optional): Quality checking commands, to check if arg2 is good.
dnl     This is run before caching result.  Generally, this would issue
dnl     a warning or error as appropriate.  For example, if this macro
dnl     is used to set the path to a program, you may want to check
dnl     if that program exist and is executable.
# Start macro BTNG_ARG_WITH_ENV_WRAPPER with args $1 and $2
AC_CACHE_CHECK(for $1,btng_cv_prog_[]translit($1,-,_),[
AC_ARG_WITH($1,
ifelse($3,,[  --with-$1	Specify $1 (same as setting $2 in environment)],[$3]))
# Set $2, using environment setting if available
#   and if command line is ambiguous.
case "$with_[]translit($1,-,_)" in
  no[)]
    # User explictly turned off $1.
    # Ignore value of $2, even if set in the environment.
    unset $2
    ;;
  yes|''[)]
    # Flag unissued or ambiguously issued using --with-$1.
    # Because the user did not explicitly turn if off,
    # try to set $2.
    # If environment variable $2 is available, use it.
    # If not, try the user-supplied commands to set it.
    if test -n "${$2}" ;  then
      : Nothing to do here actually, because $2 is already in the environment.
    else
      ifelse($4,,:,$4)
    fi
    ;;
  *)
    # User issued a specific string using --with-$1=non-null-string.
    # so that is used to set $2.
    $2=$with_[]translit($1,-,_)
    ;;
esac
dnl if test ! "${$2+set}" = set ; then
dnl   # $2 is still unset, after processing --with-$1 flag,
dnl   # and possibly using optional command to set it.
dnl   # At this point, check to make sure it is not required.
dnl   # if it is, then we have an error.
dnl   case "$with_[]translit($1,-,_)" in
dnl     no|'')
dnl       : $2 is not set but it is ok because user did not
dnl       : explicitly ask for it by issuing --with-$1=something.
dnl       ;;
dnl     *)
dnl       # If user explicitly asked for $1 and we cannot find it[,]
dnl       # that is an error
dnl       AC_MSG_ERROR(cannot find appropriate value for $2)
dnl       ;;
dnl   esac
dnl fi
if test "${$2+set}" = set ; then
  # This block executes the quality check commands, if any, for $2.
  ifelse($5,,:,$5)
fi
# Cache the value if it was found.
if test "${$2+set}" = set ; then
  btng_cv_prog_[]translit($1,-,_)=${$2}
fi
])
dnl This part runs if $2 should be set from cache.
# Set $2 from cache.
# $2 is not yet set if we grabbed it from cache.
if test "${btng_cv_prog_[]translit($1,-,_)+set}" = set ; then
  $2=$btng_cv_prog_[]translit($1,-,_)
else
  unset $2
fi
# End macro BTNG_ARG_WITH_ENV_WRAPPER with args $2 and $1
])




AC_DEFUN(BTNG_PATH_PROG,[
dnl This is a high-level macro to find paths to certain programs.
dnl In addition to (possibly) running AC_ARG_WITH and AC_PATH_PROG it:
dnl   Allows the path to be set in an environment variable ($1),
dnl     useful for setting configuration during "make check" and
dnl     for avoiding manual configure options setting.
dnl   Makes sure that the program is executable, if the user explicitly
dnl     specified it.
dnl The arguments are (similar to AC_PATH_PROG):
dnl   1: Variable name to set to the path (used in BTNG_PATH_PROG).
dnl   2: Name of program being sought (used in BTNG_PATH_PROG).
dnl   3(optional): Commands to set $1 in case neither environment
dnl      nor command line options are given.  Defaults to a call to
dnl      AC_PATH_PROG($1,$2).
dnl   4(optional): Quality check commands to make sure that a
dnl      sufficiently good program is found.  Defaults to a simple
dnl      check that the program is executable.
BTNG_ARG_WITH_ENV_WRAPPER($2,$1,
[[  --with-$2=PATH	Specify path to $2 program
			(equivalent to setting $1 in environment)]]dnl
,
[
dnl Commands to run if user was not specific.
# Just set the variable to blank and check later.
$1=
],
dnl Quality check commands.
ifelse($4,,[
  # if $1 is an absolute path, make sure it is executable.
  if echo "${$1}" | grep '^/' > /dev/null && test ! -x "${$1}"; then
    AC_MSG_WARN($2 program ${$1} is not executable.)
  fi],$4)
)dnl
if test "${$1+set}" = set; then
  ifelse($3,,[AC_PATH_PROG($1,$2)],$3)
fi
])




AC_DEFUN(BTNG_ARG_WITH_PREFIX,[
dnl This is a high-level macro to set the prefix for a
dnl previously installed package.
dnl The macro arguments are:
dnl 1. package name
dnl 2. variable to contain installation prefix.
dnl 3(optional): Help message.  A generic message is provided if
dnl   this argument is empty.
dnl 4(optional): Commands to run if configure flag is not specific
dnl   and environment variable is not set.  These commands are
dnl   run if with_blah is "yes" or "".  They should set or unset
dnl   the variable named in arg2, depending on what you want
dnl   the defaul behavior to be in these cases.  The default is
dnl   to exit with an error.
# Start macro BTNG_ARG_WITH_PREFIX
BTNG_ARG_WITH_ENV_WRAPPER($1,$2,
ifelse([$3],,
[[  --with-$1=PATH	Specify prefix where $1 is installed
			(equivalent to setting $2 in the environment)]]
,[[[$3]]]),
ifelse([$4],,
[[if test "${with_[]translit($1,-,_)}" = yes ; then
  AC_MSG_ERROR([[If you specify --with-$1, you must give it the path as in --with-$1=/installation/path]])
fi
BTNG_AC_LOG(environment $2 not defined)
]],[[[$4]]])
)dnl
# End macro BTNG_ARG_WITH_PREFIX
])




dnl $Id: support-fortran.m4,v 1.3 2002/03/19 01:32:30 gunney Exp $
dnl
dnl This file contains functions to crudely determine
dnl loader flags for linking C/C++ and Fortran.

AC_DEFUN(BTNG_LIB_C_FORTRAN,
# Start macro $1
[
dnl Use this macro to set fortran_LIBS to the library flgas
dnl needed to link in fortran from C codes.
dnl
dnl The macro AC_F77_LIBRARY_LDFLAGS, which was installed
dnl with autoconf, did not work for me.  BTNG.

if test -z "$fortran_LIBS" ; then
  # Guessing the correct flags is just based on past experience.
  # But it seems to work well in this case.  We rely heavily on
  # the name of compiler, so compilers with strange names will
  # not successfily be guessed.
  AC_REQUIRE([BTNG_INFO_CC_CXX_ID])
  BTNG_AC_LOG(Guessing fortran_LIBS in $1)
  case "$CXX_ID" in
    gnu)	# The GNU compiler.
      BTNG_AC_LOG(About to check for RedHat gnu-2.96 compiler)
      BTNG_AC_LOG_VAR(CXX_ID CXX_VERSION)
      case "$host_os" in
	# linux*)		fortran_LIBS=
	linux*)		fortran_LIBS='-lg2c'
        if test "$CXX_VERSION" = "2.96" ; then
	  # Fix problem with RedHat distribution of experimental
	  # gcc version 2.96 not knowing where it put the g2c library.
          [ extra_path=`which $CXX | sed 's:bin/[^/]*$:lib:'` ]
      	  BTNG_AC_LOG_VAR(extra_path)
	  test -d "$extra_path/gcc-lib/i386-redhat-linux/2.96" && extra_path="$extra_path/gcc-lib/i386-redhat-linux/2.96"
      	  BTNG_AC_LOG_VAR(extra_path)
	  if test -d "$extra_path" ; then
	    BTNG_AC_LOG(Adding $extra_path to fortran_LIBS)
	    fortran_LIBS="-L$extra_path $fortran_LIBS"
	  fi
        fi
	;;
	solaris*)	fortran_LIBS='-lg2c' ;;
      esac
    ;;
    kai)	# The KCC compiler runs on many platforms.
      # This compiler usually uses the native loader so use the
      # flags from the native compiler/loader.
      case "$host_os" in
	osf*)		fortran_LIBS='-lfor' ;;
	linux*)		fortran_LIBS='-lg2c' ;;
	sun*|solaris*)	fortran_LIBS='-lF77 -lM77 -lV77 -lsunmath' ;;
	sgi)		fortran_LIBS='-lftn' ;;
      esac
    ;;
    sgi)	# SGI compiler.
        fortran_LIBS='-lftn'
    ;;
    sunpro)		# Sunpro compiler.
	fortran_LIBS='-lF77 -lM77 -lV77 -lsunmath'
    ;;
    dec)	# The DEC compiler.
	fortran_LIBS='-lfor'
    ;;
  esac
fi

]
# End macro $1
)dnl	End definition of BTNG_LIB_C_FORTRAN



AC_DEFUN(BTNG_SUPPORT_FORTRAN_FROM_C,
# Begin macro $1
[
dnl Use this macro if you have to link with Fortran codes.
dnl The macro AC_F77_LIBRARY_LDFLAGS, which was installed
dnl with autoconf, did not work for me.  BTNG.
dnl
dnl Arg1: empty if you want the default to be off.
dnl
BTNG_ARG_WITH_ENV_WRAPPER(fortran-libs, fortran_LIBS,
ifelse($1,,
[  --with-fortran-libs[=LIBS]
		Enable support for linking with FORTRAN code
		and optionally specify the FORTRAN library flags.],
[  --with-fortran-libs=LIBS
		Specify the FORTRAN library linking flags.]),
[[BTNG_LIB_C_FORTRAN]]
)
BTNG_AC_LOG_VAR(fortran_LIBS)
]
# End macro $1
)



dnl Define macros for supporting z compression library.
dnl $Id: support-libz.m4,v 1.11 2002/01/30 16:33:49 gunney Exp $

AC_DEFUN(BTNG_VAR_SET_LIBZ,[
dnl Provides support for the z compression library.
dnl
dnl Arguments are:
dnl 1. Name of variable to set to path where z compression library is installed.
dnl    Nothig is done if this variable is unset.
dnl 2. Name of the INCLUDES variable similar to the automake INCLUDES variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl 3. Name of the LIBS variable similar to the automake LIBS variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl
dnl If arg1 is defined, assume that the user wants z compression
dnl support.  Do so by assigning arg2 and arg3 if they are not defined.
dnl
# End macro BTNG_VAR_SET_LIBZ
if test "${$1+set}" = set ; then
  if test ! "${$2+set}" = set ; then
    test -n "${$1}" && $2="-I${$1}/include"
  fi
  if test ! "${$3+set}" = set ; then
    btng_save_LIBS="$LIBS";	# Save for later recovery.
    btng_extra_libs=
    test -n "${$1}" && LIBS="-L${$1}/lib $LIBS"	# To facilitate library search.
    # Look for library.
    AC_SEARCH_LIBS([zlibVersion],z,[
      $3=`echo " $LIBS" | sed "s! $btng_save_LIBS!!"`; # Action if found
      test -n "${$1}" &&	\
	$3="-L${$1}/lib ${$3}"	# Add path flag to output variable.
      BTNG_AC_LOG_VAR($3, Found z compression library flag)
      ],[
      BTNG_AC_LOG_VAR($3, Did not find z compression library flag)
      ],[
      $btng_extra_libs
      ])
    LIBS="$btng_save_LIBS";	# Restore global-use variable.
  else
    BTNG_AC_LOG(Not looking for libz because $3 is not set)
  fi
fi
# End macro BTNG_VAR_SET_LIBZ
])dnl



AC_DEFUN(BTNG_SUPPORT_LIBZ,[
dnl Support z compression library by setting the variables
dnl libz_PREFIX, libz_INCLUDES, and libz_LIBS.
dnl Arg1: non-empty if you want the default to be on.
dnl
# Begin macro BTNG_SUPPORT_LIBZ

BTNG_ARG_WITH_ENV_WRAPPER(libz, libz_PREFIX,
ifelse($1,,
[  --with-libz[=PATH]
			Use z compression and optionally specify where
			it is installed.],
[  --without-libz	Do not use the z compression library.]),
ifelse($1,,unset libz_PREFIX; test "${with_libz+set}" = set && libz_PREFIX=,libz_PREFIX=))

BTNG_ARG_WITH_PREFIX(libz-includes,libz_INCLUDES,
[  --with-libz-includes=STRING
			Specify the INCLUDES flags for z compression.
			If not specified, and --with-libz=PATH is,
			this defaults to "-IPATH/include".])dnl

BTNG_ARG_WITH_PREFIX(libz-libs,libz_LIBS,
[  --with-libz-libs=STRING
			Specify LIBS flags for z compression.
			If not specified, and --with-libz=PATH is,
			this defaults to "-LPATH/lib -llapack -lblas".])dnl

BTNG_VAR_SET_LIBZ(libz_PREFIX,libz_INCLUDES,libz_LIBS)
# End macro BTNG_SUPPORT_LIBZ
])

dnl $Id: support-nsl.m4,v 1.5 2002/03/12 17:37:29 gunney Exp $

AC_DEFUN(BTNG_VAR_SET_NSL,[
dnl Provides support for the nsl library.
dnl
dnl Arguments are:
dnl 1. Name of variable to set to path where nsl are installed.
dnl    Nothig is done if this variable is unset.
dnl 2. Name of the INCLUDES variable similar to the automake INCLUDES variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl 3. Name of the LIBS variable similar to the automake LIBS variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl
dnl If arg1 is defined, assume that the user wants nsl
dnl support.  Do so by assigning arg2 and arg3 if they are not defined.
dnl
if test "${$1+set}" = set ; then
  if test ! "${$2+set}" = set ; then
    test -n "${$1}" && $2="-I${$1}/include"
  fi
  if test ! "${$3+set}" = set ; then
    btng_save_LIBS="$LIBS";	# Save for later recovery.
    test -n "${$1}" &&	\
      LIBS="-L${$1}/lib $LIBS"	# Add path flag for library search.
    # Look for library.
    AC_SEARCH_LIBS([getnetname],nsl,[
      $3=`echo " $LIBS" | sed "s! $btng_save_LIBS!!"`; # Action if found
      test -n "${$1}" &&	\
        $3="-L${$1}/lib ${$3}"	# Add path flag to output variable.
      BTNG_AC_LOG_VAR($3, Found nsl library flag)
      ],[
      BTNG_AC_LOG_VAR($3, Did not find nsl library flag)
      ])
    LIBS="$btng_save_LIBS";	# Restore global-use variable.
  fi
fi
])dnl



AC_DEFUN(BTNG_SUPPORT_NSL,[
dnl Support nsl library by setting the variables
dnl nsl_PREFIX, nsl_INCLUDES, and nsl_LIBS.
dnl Arg1: non-empty if you want the default to be on.
dnl
# Begin macro BTNG_SUPPORT_NSL

BTNG_ARG_WITH_ENV_WRAPPER(nsl, nsl_PREFIX,
ifelse($1,,
[  --with-nsl[=PATH]
			Use nsl and optionally specify where
			it is installed.],
[  --without-nsl	Do not use the nsl library.]),
ifelse($1,,unset nsl_PREFIX; test "${with_nsl+set}" = set && nsl_PREFIX=,nsl_PREFIX=))

BTNG_ARG_WITH_PREFIX(nsl-includes,nsl_INCLUDES,
[  --with-nsl-includes=STRING
			Specify the INCLUDES flags for nsl.
			If not specified, and --with-nsl=PATH is,
			this defaults to "-IPATH/include".])dnl

BTNG_ARG_WITH_PREFIX(nsl-libs,nsl_LIBS,
[  --with-nsl-libs=STRING
			Specify LIBS flags for nsl.
			If not specified, and --with-nsl=PATH is,
			this defaults to "-LPATH/lib -lnsl".])dnl

BTNG_VAR_SET_NSL(nsl_PREFIX,nsl_INCLUDES,nsl_LIBS)
# End macro BTNG_SUPPORT_NSL
])

dnl $Id: support-socket.m4,v 1.5 2002/01/30 16:33:49 gunney Exp $

AC_DEFUN(BTNG_VAR_SET_SOCKET,[
dnl Provides support for the socket library.
dnl
dnl Arguments are:
dnl 1. Name of variable to set to path where socket are installed.
dnl    Nothig is done if this variable is unset.
dnl 2. Name of the INCLUDES variable similar to the automake INCLUDES variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl 3. Name of the LIBS variable similar to the automake LIBS variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl
dnl If arg1 is defined, assume that the user wants socket
dnl support.  Do so by assigning arg2 and arg3 if they are not defined.
dnl
if test "${$1+set}" = set ; then
  BTNG_AC_LOG($1,$1 is set)
  if test ! "${$2+set}" = set ; then
    test -n "${$1}" && $2="-I${$1}/include"
  fi
  if test ! "${$3+set}" = set ; then
    BTNG_AC_LOG($3,$3 is not set)
    btng_save_socket_LIBS="$LIBS";	# Save for later recovery.
    test -n "${$1}" &&	\
      LIBS="-L${$1}/lib $LIBS"	# Add path flag for library search.
    # Look for library.
    AC_SEARCH_LIBS([getsockname],socket,[
      BTNG_AC_LOG("removing btng_save_socket_libs <$btng_save_socket_LIBS> from LIBS <$LIBS>")
      $3=`echo " $LIBS" | sed "s! $btng_save_socket_LIBS!!"`; # Action if found
      test -n "${$1}" &&	\
        $3="-L${$1}/lib ${$3}"	# Add path flag to output variable.
      BTNG_AC_LOG_VAR($3, Found socket library flag)
      ],[
      BTNG_AC_LOG_VAR($3, Did not find socket library flag)
      ])
    LIBS="$btng_save_socket_LIBS";	# Restore global-use variable.
  fi
fi
])dnl



AC_DEFUN(BTNG_SUPPORT_SOCKET,[
dnl Support socket library by setting the variables
dnl socket_PREFIX, socket_INCLUDES, and socket_LIBS.
dnl Arg1: non-empty if you want the default to be on.
dnl
# Begin macro BTNG_SUPPORT_SOCKET

BTNG_ARG_WITH_ENV_WRAPPER(socket, socket_PREFIX,
ifelse($1,,
[  --with-socket[=PATH]
			Use socket and optionally specify where
			it is installed.],
[  --without-socket	Do not use the socket library.]),
ifelse($1,,unset socket_PREFIX; test "${with_socket+set}" = set && socket_PREFIX=,socket_PREFIX=))

BTNG_ARG_WITH_PREFIX(socket-includes,socket_INCLUDES,
[  --with-socket-includes=STRING
			Specify the INCLUDES flags for socket.
			If not specified, and --with-socket=PATH is,
			this defaults to "-IPATH/include".])dnl

BTNG_ARG_WITH_PREFIX(socket-libs,socket_LIBS,
[  --with-socket-libs=STRING
			Specify LIBS flags for socket.
			If not specified, and --with-socket=PATH is,
			this defaults to "-LPATH/lib -llapack -lblas".])dnl

BTNG_AC_LOG(Setting socket variables)
BTNG_VAR_SET_SOCKET(socket_PREFIX,socket_INCLUDES,socket_LIBS)
BTNG_AC_LOG_VAR(socket_PREFIX socket_INCLUDES socket_LIBS)
# End macro BTNG_SUPPORT_SOCKET
])

dnl Define a macro for supporting MPICH.


AC_DEFUN(BTNG_SUPPORT_MPICH,[
dnl Support mpich libraries by setting the variables
dnl mpich_PREFIX, mpich_INCLUDES, and mpich_LIBS.
dnl Arg1: empty if you want the default to be on.
dnl
# Begin macro BTNG_SUPPORT_MPICH
BTNG_ARG_WITH_ENV_WRAPPER(mpich, mpich_PREFIX,
ifelse($1,,
[  --with-mpich=PATH	Use MPICH and optionally specify where it is installed.],
[  --without-mpich	Do not use the MPICH library.]),
ifelse($1,,mpich_PREFIX=,unset mpich_PREFIX))
BTNG_VAR_SET_MPICH(mpich_PREFIX,mpich_INCLUDES,mpich_LIBS)
BTNG_AC_LOG_VAR(mpich_PREFIX mpich_INCLUDES mpich_LIBS)
# End macro BTNG_SUPPORT_MPICH
])


AC_DEFUN(BTNG_VAR_SET_MPICH,[
dnl Provides support for the blas and lapack libraries.
dnl
dnl Arguments are:
dnl 1. Name of variable to set to path where mpich is installed.
dnl    Nothig is done if this variable is unset.
dnl 2. Name of the INCLUDES variable similar to the automake INCLUDES variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl 3. Name of the LIBS variable similar to the automake LIBS variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl
dnl If arg1 is defined, assume that the user wants blas and lapack
dnl support.  Do so by assigning arg2 and arg3 if they are not defined.
dnl
# Begin macro BTNG_VAR_SET_MPICH
if test "${$1+set}" = set ; then
  if test ! "${$2+set}" = set ; then
    if test -n "${$1}" ; then
      $2="-I${$1}/include"
      if test -d ${$1}/include/mpi2c++; then
        $2="${$2} -I${$1}/include/mpi2c++"
	BTNG_AC_LOG(Found mpi2c++ include directory ${$1}/include/mpi2c++)
      fi
    fi
  fi
  if test ! "${$3+set}" = set ; then
    $3="-lmpich"
    if test -n "${$1}" ; then
      for i in ${$3} ; do
	tmp_name=`echo $i | sed 's/^-l//'`
        if test ! -f "${$1}/lib/lib${tmp_name}.a" && \
          test ! -f "${$1}/lib/lib${tmp_name}.so"; then
          AC_MSG_WARN(Library file ${tmp_name} seems to be missing from ${$1}.)
        fi
      done
      $3="-L${$1}/lib ${$3}"
    fi
  fi
fi
# End macro BTNG_VAR_SET_MPICH
])dnl


AC_DEFUN(BTNG_SUPPORT_MPICH_OBSOLETE,[

# Begin BTNG_SUPPORT_MPICH
# Defines mpich_PREFIX mpich_INCLUDES and mpich_LIBS if with-mpich is specified.

BTNG_ARG_WITH_ENV_WRAPPER(mpich, mpich_PREFIX,
[  --with-mpich=PATH  Use MPICH and optionally specify where MPICH is installed.],
with_mpich=no)

BTNG_AC_LOG_VAR(with_mpich)
case "$with_mpich" in
  no)
    BTNG_AC_LOG(Not setting up for MPICH)
    unset mpich_PREFIX mpich_INCLUDES mpich_LIBS
  ;;
  yes)
    # with-mpich was given, but install path was not specified.
    # If there is an mpi2c++ directory in one of the standard include places,
    # MPICH header files are there.
    BTNG_AC_LOG(Looking for MPICH installation)
    for dir in /usr /usr/local; do
      if test -d ${dir}/include/mpi2c++; then
        mpich_INCLUDES="-I${dir}/include/mpi2c++"
	BTNG_AC_LOG(Found mpi2c++ include directory ${dir}/include/mpi2c++)
        break
      fi
    done
  ;;
  *)
    # MPICH install path was specified.
    BTNG_AC_LOG(Expect MPICH installation in $with_mpich)
    mpich_PREFIX=$with_mpich
    mpich_INCLUDES="-I${mpich_PREFIX}/include -I${mpich_PREFIX}/include/mpi2c++"
    mpich_LIBS='-L'"${mpich_PREFIX}"'/lib'" ${mpich_LIBS}"
    BTNG_AC_LOG(Set mpich_INCLUDES to $mpich_INCLUDES)
  ;;
esac
mpich_LIBS="$mpich_LIBS -lmpich"
BTNG_AC_LOG_VAR(mpich_PREFIX mpich_INCLUDES mpich_LIBS)

BTNG_PATH_PROG(mpirun, mpich_MPIRUN,
[
# Prefer the mpirun under mpich_PREFIX.
test -n "$mpich_PREFIX" &&	\
test -x "$mpich_PREFIX/bin/mpirun" &&	\
mpich_MPIRUN="$mpich_PREFIX/bin/mpirun"
])
if test -n "$mpich_MPIRUN"; then
AC_PATH_PROG(mpirun,mpich_MPIRUN)
fi

# END BTNG_SUPPORT_MPICH

])dnl End definition of BTNG_SUPPORT_MPICH

dnl Define macros for supporting HDF5.
dnl $Id: support-hdf5.m4,v 1.11 2002/03/19 01:04:33 gunney Exp $

AC_DEFUN(BTNG_VAR_SET_HDF5,[
dnl Provides support for the blas and lapack libraries.
dnl
dnl Arguments are:
dnl 1. Name of variable to set to path where hdf5 is installed.
dnl    Nothig is done if this variable is unset.
dnl 2. Name of the INCLUDES variable similar to the automake INCLUDES variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl 3. Name of the LIBS variable similar to the automake LIBS variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl
dnl If arg1 is defined, assume that the user wants hdf5 support.
dnl Do so by assigning arg2 and arg3 if they are not defined.
dnl
# Begin macro BTNG_VAR_SET_HDF5
if test "${$1+set}" = set ; then
  if test ! "${$2+set}" = set ; then
    test -n "${$1}" && $2="-I${$1}/include"
  fi
  if test ! "${$3+set}" = set ; then
    # Save for later recovery.
    btng_save_LIBS="$LIBS";
    # Extra libraries specific to this check.
    btng_extra_libs="$libz_LIBS -lm"
    # If a path is given, use it in the extra libs string.
    test -n "${$1}" && btng_extra_libs="-L${$1}/lib $btng_extra_libs"
    # Look for library.
    AC_SEARCH_LIBS([H5get_libversion],hdf5,[
      BTNG_AC_LOG_VAR(LIBS,After finding hdf5 flag)
      $3=`echo " $LIBS" | sed "s! $btng_save_LIBS!!"`; # Action if found
      # $3="$LIBS":	# Action if found
      # If path is given, add it to output variable.
      test -n "${$1}" && $3="-L${$1}/lib ${$3}"
      BTNG_AC_LOG_VAR($3, Found hdf5 library flag)
      ],[
      BTNG_AC_LOG_VAR($3, Did not find hdf5 library flag)
      AC_MSG_WARN(
[I could not systematically find the name of
the hdf5 library so I am using -lhdf5 instead.])
      $3="-lhdf5"
      test -n "${$1}" &&	\
	$3="-L${$1}/lib ${$3}"	# Add path flag to output variable.
      ],[
      $btng_extra_libs
      ])
    LIBS="$btng_save_LIBS";	# Restore global-use variable.
  else
    BTNG_AC_LOG(Not looking for hdf5 because $3 is not set)
  fi
fi
# End macro BTNG_VAR_SET_HDF5
])dnl



AC_DEFUN(BTNG_SUPPORT_HDF5,[
dnl Support hdf5 libraries by setting the variables
dnl hdf5_PREFIX, hdf5_INCLUDES, and hdf5_LIBS.
dnl Arg1: empty if you want the default to be off.
dnl
# Begin macro BTNG_SUPPORT_HDF5
BTNG_ARG_WITH_ENV_WRAPPER(hdf5, hdf5_PREFIX,
ifelse($1,,
[  --with-hdf5[=PATH]	Use HDF5 and optionally specify where it is installed.],
[  --without-hdf5	Do not use the HDF5 library.]),
ifelse($1,,unset hdf5_PREFIX; test "${with_hdf5+set}" = set && hdf5_PREFIX=,hdf5_PREFIX=))
BTNG_VAR_SET_HDF5(hdf5_PREFIX,hdf5_INCLUDES,hdf5_LIBS)
BTNG_AC_LOG_VAR(hdf5_PREFIX hdf5_INCLUDES hdf5_LIBS)
# End macro BTNG_SUPPORT_HDF5
])



dnl $Id: support-blaslapack.m4,v 1.9 2002/01/30 16:33:49 gunney Exp $

AC_DEFUN(BTNG_VAR_SET_BLAS,[
dnl Provides support for the blas library.
dnl
dnl Arguments are:
dnl 1. Name of variable to set to path where blas are installed.
dnl    Nothig is done if this variable is unset.
dnl 2. Name of the INCLUDES variable similar to the automake INCLUDES variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl 3. Name of the LIBS variable similar to the automake LIBS variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl
dnl If arg1 is defined, assume that the user wants blas
dnl support.  Do so by assigning arg2 and arg3 if they are not defined.
dnl
if test "${$1+set}" = set ; then
  if test ! "${$2+set}" = set ; then
    test -n "${$1}" && $2="-I${$1}/include"
  fi
  if test ! "${$3+set}" = set ; then
    # Save for later recovery.
    btng_save_LIBS="$LIBS";
    # Extra libraries specific to this check.
    btng_extra_libs="-lm"
    # If a path is given, use it in the extra libs string.
    test -n "${$1}" && btng_extra_libs="-L${$1}/lib $btng_extra_libs"
    # Look for library.
    AC_SEARCH_LIBS([daxpy_],blas,[
      BTNG_AC_LOG_VAR(LIBS,After finding blas flag)
      $3=`echo " $LIBS" | sed "s! $btng_save_LIBS!!"`; # Action if found
      # $3="$LIBS":	# Action if found
      # If path is given, add it to output variable.
      test -n "${$1}" && $3="-L${$1}/lib ${$3}"
      BTNG_AC_LOG_VAR($3, Found blas library flag)
      ],[
      BTNG_AC_LOG_VAR($3, Did not find blas library flag)
      AC_MSG_WARN(
[I could not systematically find the name of
the blas library so I am using -lblas instead.])
      $3="-lblas"
      test -n "${$1}" &&	\
	$3="-L${$1}/lib ${$3}"	# Add path flag to output variable.
      ],[
      $btng_extra_libs
      ])
    LIBS="$btng_save_LIBS";	# Restore global-use variable.
  else
    BTNG_AC_LOG(Not looking for blas because $3 is not set)
  fi
fi
])dnl

AC_DEFUN(BTNG_VAR_SET_LAPACK,[
dnl Provides support for the lapack library.
dnl
dnl Arguments are:
dnl 1. Name of variable to set to path where lapack are installed.
dnl    Nothig is done if this variable is unset.
dnl 2. Name of the INCLUDES variable similar to the automake INCLUDES variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl 3. Name of the LIBS variable similar to the automake LIBS variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl
dnl If arg1 is defined, assume that the user wants lapack
dnl support.  Do so by assigning arg2 and arg3 if they are not defined.
dnl
if test "${$1+set}" = set ; then
  if test ! "${$2+set}" = set ; then
    test -n "${$1}" && $2="-I${$1}/include"
  fi
  if test ! "${$3+set}" = set ; then
    # Save for later recovery.
    btng_save_LIBS="$LIBS";
    # Extra libraries specific to this check.
    btng_extra_libs="-lm"
    # If a path is given, use it in the extra libs string.
    test -n "${$1}" && btng_extra_libs="-L${$1}/lib $btng_extra_libs"
    # Look for library.
    AC_SEARCH_LIBS([xerbla_],lapack,[
      BTNG_AC_LOG_VAR(LIBS,After finding lapack flag)
      $3=`echo " $LIBS" | sed "s! $btng_save_LIBS!!"`; # Action if found
      # $3="$LIBS":	# Action if found
      # If path is given, add it to output variable.
      test -n "${$1}" && $3="-L${$1}/lib ${$3}"
      BTNG_AC_LOG_VAR($3, Found lapack library flag)
      ],[
      BTNG_AC_LOG_VAR($3, Did not find lapack library flag)
      AC_MSG_WARN(
[I could not systematically find the name of
the lapack library so I am using -llapack instead.])
      $3="-llapack"
      test -n "${$1}" &&	\
	$3="-L${$1}/lib ${$3}"	# Add path flag to output variable.
      ],[
      $btng_extra_libs
      ])
    LIBS="$btng_save_LIBS";	# Restore global-use variable.
  else
    BTNG_AC_LOG(Not looking for lapack because $3 is not set)
  fi
fi
])dnl




AC_DEFUN(BTNG_SUPPORT_BLASLAPACK,[
dnl Support blas and lapack libraries by setting the variables
dnl blaslapack_PREFIX, blaslapack_INCLUDES, and blaslapack_LIBS.
dnl Arg1: non-empty if you want the default to be on.
dnl
# Begin macro BTNG_SUPPORT_BLASLAPACK

BTNG_ARG_WITH_ENV_WRAPPER(blaslapack, blaslapack_PREFIX,
ifelse($1,,
[  --with-blaslapack[=PATH]
			Use blas and lapack and optionally specify where
			they are installed.],
[  --without-blaslapack	Do not use the blas and lapack libraries.]),
if test "${with_blaslapack+set}" = set; then
  blaslapack_PREFIX=
else
ifelse($1,,unset blaslapack_PREFIX,blaslapack_PREFIX=)
fi
)

BTNG_ARG_WITH_PREFIX(blaslapack-includes,blaslapack_INCLUDES,
[  --with-blaslapack-includes=STRING
			Specify the INCLUDES flags for blas and lapack.
			If not specified, and --with-blaslapack=PATH is,
			this defaults to "-IPATH/include".])dnl

BTNG_ARG_WITH_PREFIX(blaslapack-libs,blaslapack_LIBS,
[  --with-blaslapack-libs=STRING
			Specify LIBS flags for blas and lapack.
			If not specified, and --with-blaslapack=PATH is,
			this defaults to "-LPATH/lib -llapack -lblas".])dnl

# Look for blas and lapack flags separately.
# Then combine them.
if test "${blaslapack_PREFIX+set}" = set; then
  blas_PREFIX="$blaslapack_PREFIX"
  lapack_PREFIX="$blaslapack_PREFIX"
fi
BTNG_VAR_SET_BLAS(blas_PREFIX,blas_INCLUDES,blas_LIBS)
BTNG_VAR_SET_LAPACK(lapack_PREFIX,lapack_INCLUDES,lapack_LIBS)

# Combine include flags from blas and lapack without repeating -I flags.
if test -n "$blas_INCLUDES" || test -n "$lapack_INCLUDES" ; then
unset blaslapack_INCLUDES
for i in $lapack_INCLUDES $blas_INCLUDES ; do
  case $i in
  -I*) 
    echo "${blaslapack_INCLUDES}" | egrep "($i\$|$i[[ 	]] *)" > /dev/null	\
      && continue	# already contains the flag we want to add.
    blaslapack_INCLUDES="$blaslapack_INCLUDES $i"
    ;;
  esac
done
fi

# Combine lib flags from blas and lapack without repeating -L flags.
if test -n "$blas_LIBS" || test -n "$lapack_LIBS" ; then
unset blaslapack_LIBS
for i in $lapack_LIBS $blas_LIBS ; do
  case $i in
  -L*) 
    echo "${blaslapack_LIBS}" | egrep "($i\$|$i[[ 	]] *)" > /dev/null	\
      && continue	# already contains the flag we want to add.
    blaslapack_LIBS="$blaslapack_LIBS $i"
    ;;
  esac
done
for i in $lapack_LIBS $blas_LIBS ; do
  case $i in
  -L*) : ;;
  *) blaslapack_LIBS="$blaslapack_LIBS $i";
  esac
done
fi

BTNG_AC_LOG_VAR(blaslapack_PREFIX blaslapack_INCLUDES blaslapack_LIBS)
# End macro BTNG_SUPPORT_BLASLAPACK
])

dnl $Id: support-petsc.m4,v 1.15 2002/03/19 01:32:30 gunney Exp $

AC_DEFUN(BTNG_SUPPORT_PETSC,[
# Begin macro SUPPORT_PETSC
dnl Support PETSC by setting PETSC_DIR, PETSC_ARCH,
dnl petsc_INCLUDE and petsc_LIBS.
dnl Support --with-petsc-optimize to use optimized PETSC library.
dnl Support --with-petsc-mpiuni to use PETSC uniprocessor MPI library.
dnl
dnl Arg1: non-empty if you want the default to be on.
dnl
dnl This version supports PETSc-2.1.0

# Set PETSC_DIR to the PETSC root directory.
BTNG_ARG_WITH_PREFIX(petsc,PETSC_DIR,
ifelse($1,,
[  --with-petsc=PATH	Support PETSc, and specify PETSC top-level directory],
[  --without-petsc	Do not support PETSc])
,
# User was not specific about specifying PETSc.
ifelse($1,,
# PETSc should be off by default.
# So if user specified --with-petsc, it should include a path or it is an error.
if test "${with_petsc+set}" = set ; then
  # User specified --with-petsc ambiguously.
  AC_MSG_ERROR([You must specify a path with --with-petsc=...])
else
  # User did not specify --with-petsc, so turn it off.
  unset PETSC_DIR;
fi
,
# PETSc should be on by default.
# So require that user say where it is or turn it off.
AC_MSG_ERROR([You must specify either --with-petsc=... or --without-petsc.])
))

# Set PETSC_ARCH.
BTNG_ARG_WITH_PREFIX(petsc-arch,PETSC_ARCH,
[  --with-petsc-arch=PETSC_ARCH
			Specify the PETSC architecture])

# Set PETSC_OPTIMIZE.
BTNG_ARG_WITH_ENV_WRAPPER(petsc-optimize,PETSC_OPTIMIZE,
[  --with-petsc-optimize
			Use the optimized PETSC libraries],
# By default, use the debug PETSC library.
PETSC_OPTIMIZE=g
BTNG_AC_LOG_VAR(with_petsc_optimize)
test "$with_petsc_optimize" = yes && PETSC_OPTIMIZE=O
)

# Set PETSC_MPIUNI.
BTNG_ARG_WITH_ENV_WRAPPER(petsc-mpiuni,PETSC_MPIUNI,
[  --with-petsc-mpiuni	Use the PETSC uniprocessor MPI library],
# By default, do not use the PETSC uniprocessor MPI library.
unset PETSC_MPIUNI
)

# Set PETSC_LIBFILES
unset PETSC_LIBFILES
AC_ARG_WITH(petsc-libfiles,
[  --with-petsc-libfiles
			Specify explit PETSc library files instead
			of -L and -l flags (may help some debuggers)],
test "$with_petsc_libfiles" = yes && PETSC_LIBFILES=yes)


if test "${PETSC_DIR+set}" = set; then
  # Set up PETSC only if PETSC_DIR is defined.

  if test ! -d "$PETSC_DIR"; then
    AC_MSG_WARN([PETSC directory ($PETSC_DIR) does not look right])
  fi
  if test -z "$PETSC_ARCH"; then
    PETSC_ARCH=`$PETSC_DIR/bin/petscarch`
  fi
  BTNG_AC_LOG_VAR(PETSC_ARCH)
  if test ! -d "$PETSC_DIR/bmake/$PETSC_ARCH"; then
    AC_MSG_WARN([PETSC architecture ($PETSC_ARCH) does not look right])
  fi
  if test ! "$PETSC_OPTIMIZE" = g && test ! "$PETSC_OPTIMIZE" = O; then
    AC_MSG_ERROR([PETSC optimize should be either g or O])
  fi

  petsc_INCLUDES="-I$PETSC_DIR/include -I$PETSC_DIR/bmake/$PETSC_ARCH"
  petsc_INCLUDES="$petsc_INCLUDES -I$PETSC_DIR/src/vec"
  # Currently, I'm not entirely sure why we have to explicitly specify
  # the src/vec directory in the include path.  But there is at least
  # one required file there that cannot be found in the include directory.

  petsc_LIBDIR="${PETSC_DIR}/lib/lib${PETSC_OPTIMIZE}/${PETSC_ARCH}"

  # Issue the -L flag if not specifying PETSc libraries by file names.
  test ! "${PETSC_LIBFILES+set}" = set && petsc_LIBS="-L${petsc_LIBDIR}"

  # Build up a list of PETSC library files.
  petsc_libs_ls1=`cd ${PETSC_DIR}/lib/lib${PETSC_OPTIMIZE}/${PETSC_ARCH} && echo lib*.*`
  if test -n "$petsc_libs_ls1"; then
    unset petsc_libs_ls
    for i in $petsc_libs_ls1; do
      j=`echo $i | sed -e 's/lib//' -e 's/\.a$//' -e 's/\.so$//'`
      if echo "$petsc_libs_ls" | grep -v " $j " > /dev/null; then # Note padding!
        petsc_libs_ls="$petsc_libs_ls $j ";	# Note space padding!
      fi
    done
  fi
  # Remove mpiuni from the list of PETSC libraries unless user asked for it.
  if test ! "${PETSC_MPIUNI}" = yes; then
    petsc_libs_ls=`echo "$petsc_libs_ls" | sed 's/ mpiuni //g'`
  fi
  # Move some low-level libraries to the end to ensure resolution
  # for linkers that only make one pass.
  for i in petscmat petsc; do
    petsc_libs_ls=`echo "$petsc_libs_ls" | sed 's/\(.*\)\( \{0,1\}'"$i"'\{0,1\} \)\(.*\)/\1 \3 \2/g'`
  done
  # Build up petsc_LIBS string using library names.
  BTNG_AC_LOG_VAR(petsc_libs_ls1 petsc_libs_ls)
  if test -n "$petsc_libs_ls"; then
    if test "${PETSC_LIBFILES+set}" = set; then
      for i in $petsc_libs_ls; do
        petsc_LIBS="$petsc_LIBS ${PETSC_DIR}/lib/lib${PETSC_OPTIMIZE}/${PETSC_ARCH}/lib${i}.a"
      done
    else
      for i in $petsc_libs_ls; do
        petsc_LIBS="$petsc_LIBS -l$i"
      done
    fi
  fi

  BTNG_AC_LOG_VAR(PETSC_DIR petsc_INCLUDES petsc_LIBS PETSC_OPTIMIZE PETSC_MPIUNI)

fi
# End macro SUPPORT_PETSC
])

dnl $Id: support-hypre.m4,v 1.7 2001/10/22 18:39:23 gunney Exp $

dnl Define macros for supporting HYPRE.


AC_DEFUN(BTNG_SUPPORT_HYPRE,[
dnl Support hypre libraries by setting the variables
dnl hypre_PREFIX, hypre_INCLUDES, and hypre_LIBS.
dnl Arg1: empty if you want the default to be off.
dnl
# Begin macro BTNG_SUPPORT_HYPRE
BTNG_ARG_WITH_ENV_WRAPPER(hypre, hypre_PREFIX,
ifelse($1,,
[  --with-hypre[=PATH]	Use HYPRE and optionally specify where it is installed.],
[  --without-hypre	Do not use the HYPRe library.]),
ifelse($1,,unset hypre_PREFIX,hypre_PREFIX=))
BTNG_VAR_SET_HYPRE(hypre_PREFIX,hypre_INCLUDES,hypre_LIBS)
BTNG_AC_LOG_VAR(hypre_PREFIX hypre_INCLUDES hypre_LIBS)
# End macro BTNG_SUPPORT_HYPRE
])


AC_DEFUN(BTNG_VAR_SET_HYPRE,[
dnl Provides support for the blas and lapack libraries.
dnl
dnl Arguments are:
dnl 1. Name of variable to set to path where hypre is installed.
dnl    Nothig is done if this variable is unset.
dnl 2. Name of the INCLUDES variable similar to the automake INCLUDES variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl 3. Name of the LIBS variable similar to the automake LIBS variable.
dnl    This variable is modified ONLY if it is NOT set.
dnl
dnl If arg1 is defined, assume that the user wants blas and lapack
dnl support.  Do so by assigning arg2 and arg3 if they are not defined.
dnl
# Begin macro BTNG_VAR_SET_HYPRE
if test "${$1+set}" = set ; then
  if test ! "${$2+set}" = set ; then
    test -n "${$1}" && $2="-I${$1}/include"
  fi
  if test ! "${$3+set}" = set ; then
    $3="-lHYPRE_struct_ls -lHYPRE_struct_mv -lHYPRE_utilities"
    if test -n "${$1}" ; then
      for i in ${$3} ; do
	tmp_name=`echo $i | sed 's/^-l//'`
        if test ! -f "${$1}/lib/lib${tmp_name}.a" && \
          test ! -f "${$1}/lib/lib${tmp_name}.so"; then
          AC_MSG_WARN(Library file for ${tmp_name} is missing from ${$1}/lib.)
        fi
      done
      $3="-L${$1}/lib ${$3}"
    fi
  fi
fi
# End macro BTNG_VAR_SET_HYPRE
])dnl

dnl $Id: support-samrai.m4,v 1.30 2002/04/11 20:04:26 gunney Exp $


AC_DEFUN(BTNG_SUPPORT_SAMRAI,[

dnl Support using SAMRAI by
dnl - Setting the variables samrai_INCLUDES and samrai_LIBS.
dnl - Creating a script to convert X-files to dimensional files,
dnl   so you can write dimensionally generic code in the SAMRAI
dnl   style.
dnl
dnl User will specify where the SAMRAI source is located (--samrai-src=...)
dnl and where SAMRAI was compiled (--samrai_compile=...).
dnl In addition, user may omit certain "dimensional libraries" in SAMRAI
dnl by specifying  --samrai-exclude-dim=string, where string contains
dnl combinations of '1', '2' and '3', the directions to exclude.
dnl
dnl This macro also sets certain variables useful when including SAMRAI
dnl sources in Doxygen documentation.
dnl
dnl SAMRAI_EXCLUDE_DIM: dimensions to exclude (some conbination of 1, 2 and 3)
dnl
dnl Arg1: Name (may include relative path) of script to convert X-files.
dnl       If omitted, this script is not created.
dnl Arg2: Name (may include path) of Makefile defining rules for
dnl       handling and automatically generating dimensional sources.
dnl       If omitted, this file is not created.

# Begin macro $0

# Set SAMRAI_COMPILE to the SAMRAI compile directory.
BTNG_ARG_WITH_PREFIX(samrai-compile,SAMRAI_COMPILE,
[  --with-samrai-compile=PATH
			Specify where the SAMRAI compile directory is located.
			This should be a properly configured SAMRAI and the
			libraries you expect to use should already be built.])
if test ! -d "$SAMRAI_COMPILE"; then
  AC_MSG_WARN([SAMRAI compile directory ($SAMRAI_COMPILE) does not look right])
fi

if test -r "$SAMRAI_COMPILE/config.status"; then
  # See if we can guess the SAMRAI source directory from the compile directory.
  # Do not issue warnings, because we may not actually need to do this,
  # depending on whether the with-samrai-src option is issued.
  tmpstr=`sed -n -e '/^srcdir=/!D' -e 's/^srcdir=//' -e p -e q $SAMRAI_COMPILE/config.status 2>/dev/null`
  test "$tmpstr" && btng_guess_samrai_src=`cd $SAMRAI_COMPILE && cd $tmpstr && pwd`
  BTNG_AC_LOG_VAR(SAMRAI_COMPILE tmpstr btng_guess_samrai_src)
fi

# Set SAMRAI_SRC to the SAMRAI source directory.
BTNG_ARG_WITH_PREFIX(samrai-src,SAMRAI_SRC,
[  --with-samrai-src=PATH
			Specify where the SAMRAI source directory is located.
			If omitted, it can be guessed from the contents of
			of a properly configured SAMRAI compile directory.]
,[
# Set SAMRAI source directory to value guessed from the compile directory.
if test -n "$btng_guess_samrai_src"; then
  SAMRAI_SRC=$btng_guess_samrai_src
fi
])
if test ! -d "$SAMRAI_SRC"; then
  AC_MSG_WARN([
SAMRAI source directory ($SAMRAI_SRC) does not look right
You can set this directory using --with-samrai-src=...
])
fi

# To reduce clutter in the link flags, this is a way to remove
# certain dimensions from the SAMRAI library.
BTNG_ARG_WITH_ENV_WRAPPER(samrai-exclude-dim,SAMRAI_EXCLUDE_DIM,
[  --with-samrai-exclude-dim=STRING
			Specify list of dimensions (1,2,3) to exclude
			from SAMRAI library],,[
  # SAMRAI_EXCLUDE_DIM may only contain 1, 2 or 3.
  SAMRAI_EXCLUDE_DIM=`echo $SAMRAI_EXCLUDE_DIM | sed 's/[[[^123]]]//g'`
])

samrai_INCLUDES="-I$SAMRAI_COMPILE/include -I$SAMRAI_SRC/include"

# Determine the samrai library names.
samrai_libs_ls1=`cd $SAMRAI_COMPILE/lib && echo libSAMRAI*.*`
if test "$samrai_libs_ls1" = 'libSAMRAI*.*'; then
  samrai_libs_ls1='libSAMRAI.a libSAMRAI1d_algs.a libSAMRAI1d_geom.a libSAMRAI1d_hier.a libSAMRAI1d_math_special.a libSAMRAI1d_math_std.a libSAMRAI1d_mesh.a libSAMRAI1d_pdat_special.a libSAMRAI1d_pdat_std.a libSAMRAI1d_solv.a libSAMRAI1d_tbox.a libSAMRAI1d_xfer.a libSAMRAI2d_algs.a libSAMRAI2d_geom.a libSAMRAI2d_hier.a libSAMRAI2d_math_special.a libSAMRAI2d_math_std.a libSAMRAI2d_mesh.a libSAMRAI2d_pdat_special.a libSAMRAI2d_pdat_std.a libSAMRAI2d_plot.a libSAMRAI2d_solv.a libSAMRAI2d_tbox.a libSAMRAI2d_xfer.a libSAMRAI3d_algs.a libSAMRAI3d_geom.a libSAMRAI3d_hier.a libSAMRAI3d_math_special.a libSAMRAI3d_math_std.a libSAMRAI3d_mesh.a libSAMRAI3d_pdat_special.a libSAMRAI3d_pdat_std.a libSAMRAI3d_plot.a libSAMRAI3d_solv.a libSAMRAI3d_tbox.a libSAMRAI3d_xfer.a'
  AC_MSG_WARN(
[I cannot find any library files in $SAMRAI_COMPILE/lib.
I am resorting to a priori knowledge of SAMRAI libraries,
which MAY be outdated.  I am assuming the following libraries:
$samrai_libs_ls1])
fi
# Remove excluded dimensions, if any.
test -n "$SAMRAI_EXCLUDE_DIM" &&	\
  [samrai_libs_ls1="`echo $samrai_libs_ls1 | sed -e 's/libSAMRAI['$SAMRAI_EXCLUDE_DIM']d_[a-zA-Z0-9_]\{1,\}\.a//g' -e 's/libSAMRAI['$SAMRAI_EXCLUDE_DIM']d_[a-zA-Z0-9_]\{1,\}\.so//g'`"]
if test -n "$samrai_libs_ls1"; then
  unset samrai_libs_ls
  for i in $samrai_libs_ls1; do
    j=`echo $i | sed -e 's/lib//' -e 's/\.a$//' -e 's/\.so$//'`
    if echo "$samrai_libs_ls" | grep -v " $j " > /dev/null; then # Note padding!
      samrai_libs_ls="$samrai_libs_ls $j ";	# Note space padding!
    fi
  done
fi
# Move some low-level libraries to the end to ensure resolution
# for linkers that only make one pass.
for d in 3 2 1; do
  for i in plot geom solv algs mesh math_std math_special pdat_std pdat_special xfer hier tbox; do
    [samrai_libs_ls=`echo "$samrai_libs_ls" | sed 's/\(.*\)\( SAMRAI'$d'd_'$i' \)\(.*\)/\1 \3 \2/g'`]
  done
done
[samrai_libs_ls=`echo "$samrai_libs_ls" | sed 's/\(.*\)\( SAMRAI \)\(.*\)/\1 \3 \2/g'`]
dnl [samrai_libs_ls=`echo "$samrai_libs_ls" | sed 's/ \{2,\}/ /g'`]
# Build up SAMRAI_LIBS string using library names.
BTNG_AC_LOG_VAR(samrai_libs_ls1 samrai_libs_ls)
if test -n "$samrai_libs_ls"; then
  for i in $samrai_libs_ls; do
    samrai_LIBS="$samrai_LIBS -l$i"
  done
fi
samrai_LIBS="-L$SAMRAI_COMPILE/lib $samrai_LIBS"

BTNG_AC_LOG_VAR(SAMRAI_EXCLUDE_DIM samrai_INCLUDES samrai_LIBS)



# The following paragraph refers to generating Doxygen documentation for
# your source code and including SAMRAI source codes also.  If you do not
# know that this means, you can ignore it.
#
# Whether and how SAMRAI sources should be included in doxygen documentation.
# These autoconf variables are available for use in a doxygen configuration
# file (usually named Doxyfile):
# SAMRAI_DOXYGEN_LOCATION
# SAMRAI_DOXYGEN_TAGFILE
# SAMRAI_DOXYGEN_INPUT
# SAMRAI_DOXYGEN_FILE_PATTERNS
# SAMRAI_DOXYGEN_EXCLUDE_PATTERNS
# SAMRAI_DOXYGEN_RECURSIVE
# SAMRAI_DOXYGEN_PREDEFINED
AC_ARG_ENABLE(samrai-dox,
[  --enable-samrai-dox=LOCATION
			Include SAMRAI sources in doxygen documentation.
			LOCATION should be a full path or URL to where
			the SAMRAI doxygen documentation resides.
			If omitted, it points to the one in the
			docs/doxygen/html directory where SAMRAI is compiled.],,
enable_samrai_dox=no)

# Set the SAMRAI doxygen location to the default if necessary.
case "$enable_samrai_dox" in
  no) unset SAMRAI_DOXYGEN_LOCATION ;;
  yes)
    # Expect SAMRAI doxygen to be in the compile directory, under docs directory.
    # Error if SAMRAI_COMPILE is null.
    if test -z "${SAMRAI_COMPILE}"; then
      AC_MSG_ERROR(
[You must specify --with-samrai-compile=PATH if you do not specify
SAMRAI doxygen documentation location using --enable-samrai-dox=LOCATION.])
    fi
    SAMRAI_DOXYGEN_LOCATION="${SAMRAI_COMPILE}/docs/samrai-dox/html"
  ;;
  *) SAMRAI_DOXYGEN_LOCATION="$enable_samrai_dox"
esac

SAMRAI_DOXYGEN_INPUT=
SAMRAI_DOXYGEN_FILE_PATTERNS=
SAMRAI_DOXYGEN_EXCLUDE_PATTERNS=
if test "${SAMRAI_DOXYGEN_LOCATION+set}" = set ; then
  # Set up substitutions that can be used to set up a Doxyfile
  # to link to the SAMRAI documentation.
  # If the user specified development documentation, modify some variables
  #   to reflect that.
  SAMRAI_DOXYGEN_TAGFILE="${SAMRAI_DOXYGEN_LOCATION}/samrai.tag"
  SAMRAI_DOXYGEN_INPUT="${SAMRAI_SRC}/source/algorithm ${SAMRAI_SRC}/source/geometry ${SAMRAI_SRC}/source/hierarchy ${SAMRAI_SRC}/source/patchdata ${SAMRAI_SRC}/source/mesh ${SAMRAI_SRC}/source/solvers ${SAMRAI_SRC}/source/toolbox ${SAMRAI_SRC}/source/transfer ${SAMRAI_SRC}/source/mathops ${SAMRAI_SRC}/source/plotting"
  SAMRAI_DOXYGEN_FILE_PATTERNS=['*.[ChI] *.[ChI].sed']
  SAMRAI_DOXYGEN_EXCLUDE_PATTERNS='*/[[123]]d/*'
  SAMRAI_DOXYGEN_RECURSIVE=YES
  SAMRAI_DOXYGEN_PREDEFINED='NDIM=3 HAVE_KINSOL HAVE_HYPRE HAVE_PETSC'
  # Create the URL string.
  SAMRAI_DOXYGEN_URL="${SAMRAI_DOXYGEN_LOCATION}"
  case "${SAMRAI_DOXYGEN_URL}" in /*) SAMRAI_DOXYGEN_URL="file:${SAMRAI_DOXYGEN_URL}"; esac
  # Warn if SAMRAI doxygen not been generated.
  if test ! -r "${SAMRAI_DOXYGEN_TAGFILE}" ; then
    AC_MSG_WARN(
[File ${SAMRAI_DOXYGEN_TAGFILE} not readable!
Maybe (cd ${SAMRAI_COMPILE}/doc && make dox) required?])
  fi
fi

AC_CONFIG_COMMANDS([samrai-tag],[
# Copy the samrai.tag file if the doxygen location is specified.
if test "${SAMRAI_DOXYGEN_LOCATION}" ; then
  if test -r "${SAMRAI_DOXYGEN_TAGFILE}" ; then
    cp -f "${SAMRAI_DOXYGEN_TAGFILE}" .
  else
    echo "Warning: SAMRAI tag file '${SAMRAI_DOXYGEN_TAGFILE}' does not exist." >&2
    echo "         in the location you specified, ${SAMRAI_DOXYGEN_LOCATION}." >&2
  fi
fi
],[
# Set the location of SAMRAI doxygen documentation directory.
SAMRAI_DOXYGEN_LOCATION="${SAMRAI_DOXYGEN_LOCATION}"
SAMRAI_DOXYGEN_TAGFILE="${SAMRAI_DOXYGEN_TAGFILE}"
])

AC_SUBST(SAMRAI_DOXYGEN_LOCATION)
AC_SUBST(SAMRAI_DOXYGEN_URL)
AC_SUBST(SAMRAI_DOXYGEN_TAGFILE)
AC_SUBST(SAMRAI_DOXYGEN_INPUT)
AC_SUBST(SAMRAI_DOXYGEN_FILE_PATTERNS)
AC_SUBST(SAMRAI_DOXYGEN_EXCLUDE_PATTERNS)
AC_SUBST(SAMRAI_DOXYGEN_RECURSIVE)
AC_SUBST(SAMRAI_DOXYGEN_PREDEFINED)
BTNG_AC_LOG_VAR(enable_samrai_dox
SAMRAI_DOXYGEN_LOCATION
SAMRAI_DOXYGEN_URL
SAMRAI_DOXYGEN_TAGFILE
SAMRAI_DOXYGEN_INPUT
SAMRAI_DOXYGEN_FILE_PATTERNS
SAMRAI_DOXYGEN_EXCLUDE_PATTERNS
SAMRAI_DOXYGEN_RECURSIVE
SAMRAI_DOXYGEN_PREDEFINED)





dnl Define the filenames for the xd script and the xd rules files.
dnl (First, make sure the macro was called properly.)
ifelse($1,,[
ifelse($2,,,[
errprint([
You must issue the name of the xd script before you can
issue the name of the xd rules file.  Line __line__ in __file__.
Exiting.
])
m4_exit(1)
])
])
define(btng_xd_script_fn,$1)
define(btng_xd_rules_fn,$2)


dnl Create the script to convert X-files.
ifelse($1,,,[
dnl Create xd.pl script.
syscmd([cat <<'__EOM__'> ]btng_xd_script_fn[
#!/usr/bin/perl

# Writes a dimensional code file from non-dimensional X file.
# Similar to updateXd.pl but works on one individual file.

use Getopt::Long;

# Define the dimension and output file name.
my $dim, $output;
&GetOptions( 'help' => \$help
	   , 'verbose' => \$verbose
	   , 'dim=i' => \$dim
	   , 'output=s' => \$output
	   );

if ( defined $help || @ARGV == 0 ) {
print <<_EOM_;
Program ${0} converts SAMRAI-style dimensional generic (X) code
into dimensional code.

Usage example:
	${0} --output=prfx_ClassName2.C prfx_ClassNameX.C.sed [extra patterns]

All patterns in the form of SAMRAI class name patterns will
be converted (the X will replaced by [123]). Any appearance
of the word NDIM will also be replaced by [123].  In addition,
patterns (Perl regular expressions) listed in [extra patterns]
will be converted.

The "X" should not be included in the extra patterns.
_EOM_
exit;
}

my $input = shift @ARGV;
@ep = @ARGV;	# Remaining arguments are extra patterns.

if ( !defined $dim && defined $output ) {
    # If dim was not given, determine it from name of output.
    ($dim=$output) =~ s/.*\w+[^\d](\d)?.[ChI]\b/\1/go;
}
elsif ( !defined $output && defined $dim && defined $input ) {
    # If output name was not given, determine it from dim and input name.
    ($output=$input) =~ s!(.*/)?([^/]+)X(.[ChI]).sed$!\2$dim\3!go;
}

# Error checking.
die "Error: Input file omitted.\n" unless defined $input;
die "Error: Output file omitted.  Use --output=NAME.\n" unless defined $output;
die "Error: Dimension omitted.  Use --dim=[123].\n" unless defined $dim;

# Verbose output.
if ( defined $verbose ) {
    print <<_EOM_;
input:	$input
output:	$output
dim:	$dim
_EOM_
}

# Read, convert and write.
open( IN, "<$input" ) || die "Cannot open input file $input";
open( OUT, ">$output" ) || die "Cannot open output file $output";
while ( $_ = <IN> ) {
    # Remove CVS-substituted strings.
    # s/\$((Id|Name|Revision|Date)[^\$]*)\$//go;
    # Change dimension.
    s/((\b|included_)(mesh|algs|geom|hier|math|pdat|solv|tbox|xfer|plot)_\w+)X(\b|_[ChI])/\1$dim\2/go;
    s/\bNDIM\b/$dim/go;
    # Change extra patterns if specified.
    if ( @ep ) { for $epi (@ep) { s/($epi)X\b/\1$dim/g; } }
    # Write out.
    print OUT "$_";
}

close IN || die "Error closing input file $input";
close OUT || die "Error closing output file $output";

exit;
# End of script.
__EOM__
])
syscmd(chmod +x btng_xd_script_fn)
])





dnl Create the (partial) Makefile to convert X-files.
ifelse($2,,,[
dnl Create Makefile.xfile-rules file.
syscmd([cat <<'__EOM__'> ]btng_xd_rules_fn[
# Rules and definitions for working with generated sources
# generated from SAMRAI's X-files.

# How to build dimension-specific sources from X-sources.
# This only works with GNU make.  Ordinary make syntax
# does not support implicit rules in a way that is compatible
# with SAMRAI's naming convention for X-files and their
# dimensional counterparts.
#
# These rules assume that you placed the X-files in a
# directory with the dimensional directories in the same
# directory (standard SAMRAI layout).
SUFFIXES = .C .h .I
XDSCRIPT = $(top_srcdir)/]btng_xd_script_fn[
DIM_SRC_DIR = 
%1.C %2.C %3.C: $(srcdir)/../%X.C.sed
	@echo "Generating $? -> $(DIM_SRC_DIR)$(@)" && $(XDSCRIPT) --output=$(DIM_SRC_DIR)$(@) $? $(EXTRA_XFILE_PATTERNS)
%1.h %2.h %3.h: $(srcdir)/../%X.h.sed
	@echo "Generating $? -> $(DIM_SRC_DIR)$(@)" && $(XDSCRIPT) --output=$(DIM_SRC_DIR)$(@) $? $(EXTRA_XFILE_PATTERNS)
%1.I %2.I %3.I: $(srcdir)/../%X.I.sed
	@echo "Generating $? -> $(DIM_SRC_DIR)$(@)" && $(XDSCRIPT) --output=$(DIM_SRC_DIR)$(@) $? $(EXTRA_XFILE_PATTERNS)
__EOM__
])
])


dnl
undefine([btng_xd_rules_fn])
undefine([btng_xd_script_fn])


# End macro $0
])



dnl $Id: support-rpath.m4,v 1.15 2002/03/06 21:51:31 gunney Exp $


AC_DEFUN(BTNG_LIBS_ADD_RPATH,[
# Begin macro BTNG_LIBS_ADD_RPATH
dnl Support RPATH by going in a LIBS string and, for each -L flag,
dnl add a flag immediately following it to set the RPATH, for
dnl paths that contain shared libraries.
dnl
dnl arg1 is a LIBS string.
dnl arg2 is the name of the variable to set to the new LIBS string.
dnl arg3 is non-empty to use id of the C++ compiler instead of the C compiler.


dnl Determine which compiler is being used, because
dnl the syntax of the RPATH flag depends on the compiler.
dnl Use the C++ compiler and assume the C compiler
dnl is from the same family.
AC_REQUIRE([BTNG_INFO_CC_CXX_ID])


AC_ARG_ENABLE(rpath,
[  --enable-rpath=SYNTAX	Use the given syntax for rpath flags
			instead of trying to figure it out.]
,,enable_rpath=yes)

if test "$enable_rpath" = yes; then
  # Determine the proper rpath syntax.

  AC_LANG_SAVE

  ifelse([$3],,
  AC_LANG_C
  btng_rpath_compiler_id="$CC_ID",
  AC_LANG_CPLUSPLUS
  btng_rpath_compiler_id="$CXX_ID"
  )


  # Unset the rpath syntax variable so we can check on whether we
  # found a way to set it.
  unset btng_rpath_beginning;

  # Determine, based on the compiler, the syntax for specifying RPATH.
  # It should be of the form "$btng_rpath_beginning$the_path", where
  # btng_rpath_beginning is the compiler-dependent part.
  case "$btng_rpath_compiler_id" in
    gnu)
      # This compiler may use a variable rpath syntax because it may use
      # the native loader.
      BTNG_LIBS_FIND_RPATH(btng_rpath_beginning,
	['---bogus-flag-meant-to-cause-error' '-Wl,-rpath ' '-Wl,-R' '-Wl,-R '])
    ;;
    sunpro)
      # This compiler may use a variable rpath syntax.
      BTNG_LIBS_FIND_RPATH(btng_rpath_beginning,['---bogus-flag-meant-to-cause-error' '-R' '-R '])
    ;;
    kai)
      # The KAI compilers use the system native loader.
      #
      # On some platforms (PC/Linux at least), this compiler seems
      # to return 0 even if it encounters error, thus it can return
      # the first guess for the rpath syntax, even if the guess is
      # wrong.  We try to catch this by making the first flag bogus.
      # If the compiler accepts this flag (by returning 0), we know
      # it is wrong and we resort to an alternative method for
      # getting the rpath syntax.
      BTNG_LIBS_FIND_RPATH(btng_rpath_beginning,
	['---bogus-flag-meant-to-cause-error' '-R' '-R ' '-rpath ' '-Wl,-rpath ' '-Wl,-R' '-Wl,-R '])
      if test "$btng_rpath_beginning" = "---bogus-flag-meant-to-cause-error"; then
        # Do not rely on the compiler return value to test for syntax
        # Guess the syntax assuming the native loader will be used.
        case "$host_os" in
          linux*) btng_rpath_beginning='-Wl,-rpath ' ;;
          sun*|solaris*) btng_rpath_beginning='-R' ;;
          osf*) btng_rpath_beginning='-rpath ' ;;
          *) btng_rpath_beginning='' ;;
        esac
        AC_MSG_WARN(
  [Your compiler ifelse($3,,$CC,$CXX) returns 0 even when it is
  given a bogus flag.  Therefore, I cannot find the proper syntax
  for the rpath for this compiler.  I have resorted to a guess that
  may not be correct: '$btng_rpath_beginning'.
  You can override this by using --enable-rpath=SYNTAX])
      fi
    ;;
    *)
      BTNG_LIBS_FIND_RPATH(btng_rpath_beginning)
    ;;
  esac
  BTNG_AC_LOG_VAR(host_os CC_ID CXX_ID btng_rpath_compiler_id btng_rpath_beginning, forming rpaths)

  AC_LANG_RESTORE

  # It is valid to have btng_rpath_beginning be blank.
  # but if it is unset, we could not find a way to set it.
  if test ! "${btng_rpath_beginning+set}" = set; then
    AC_MSG_WARN(I cannot find a working syntax for setting relocatable paths)
  fi

elif test ! "${enable_rpath}" = no; then

  # User has provide the rpath syntax.
  btng_rpath_beginning=$enable_rpath

fi;	# End block determining the proper rpath syntax.


# Use the rpath syntax.
if test "${btng_rpath_beginning+set}" = set	\
  && test -n "${btng_rpath_beginning}" ; then
  # Add the RPATH flags only if we know the syntax for it,
  # and if it is needed as indicated by a non-empty btng_rpath_beginning.

  # Loop through the flags in $1, looking for the -L flag,
  # and append RPATH flag to each one found, if the the
  # path specified by the flag includes shared libraries.
  for i in ${$1}; do
    btng_new_$2="${btng_new_$2} ${i}"
    btng_tmp_addl_string=`echo $i | sed 's/^-L//'`
    test "$btng_tmp_addl_string" = "$i" && continue	# does not contain -L.
    test -d "$btng_tmp_addl_string" || continue;	# directory nonexistent.
    test "`echo $btng_tmp_addl_string/*.so`" = "$btng_tmp_addl_string/*.so" \
      && continue;	# does not contain shared libraries.
    echo "${btng_new_$2}"	\
      | grep ".*${btng_rpath_beginning}[[ 	]]*${btng_tmp_addl_string}"	\
      > /dev/null	\
      && continue	# already contains the flag we want to add.
    btng_new_$2="${btng_new_$2} ${btng_rpath_beginning}${btng_tmp_addl_string}"
  done
  $2="${btng_new_$2}"

fi

dnl Now, arg2 should be similar to arg1, but with the additional RPATH flags.

# End macro BTNG_LIBS_ADD_RPATH
])




AC_DEFUN(BTNG_LIBS_FIND_RPATH,[
# Begin macro BTNG_LIBS_FIND_RPATH
dnl Find the correct rpath syntax from the list given in arg1.
dnl arg1: variable to set to the syntax string
dnl arg2: list of syntaxes to try;
dnl   if blank, a large number of syntaxes will be tried.
dnl
dnl arg1 is list of possible rpath syntaxes to try.
define(btng_possible_rpaths,dnl
[ifelse($2,,['-R ' '-R' '-rpath ' '-Wl,-rpath ' '-Wl,-R ' '-Wl,-R'],[[$2]])])
  btng_save_LIBS="$LIBS";
  for i in btng_possible_rpaths; do
    LIBS="${i}/usr/local"
    AC_TRY_LINK(,,$1="$i", unset $1)
    if test "${$1+set}" = set; then break; fi
  done
  LIBS="$btng_save_LIBS"
undefine([btng_possible_rpaths])
# End macro BTNG_LIBS_FIND_RPATH
])

dnl $Id: support-insure.m4,v 1.23 2002/04/10 00:55:36 gunney Exp $


AC_DEFUN(BTNG_SUPPORT_INSURE,[
# Begin macro BTNG_SUPPORT_INSURE
dnl Support INSURE through the flag --enable-insure-as-compiler.
dnl which modifies the C and C++ compiler names
dnl A Parasoft configuration .psrc file is also written.
dnl
dnl This macro creates a .psrc.in file (base name is arg1) at autoconf
dnl time and the corresponding .psrc file at configure time.  It also
dnl looks for C and C++ codes in the source tree (at autoconf time)
dnl and sets up configure-time commands to link to the top-level .psrc
dnl file at configure time.  Finally, it creates and ac_subst a command
dnl string (btng_insure_psrc_clean) for use in Makefiles to remove the
dnl links.
dnl 
dnl
dnl arg1: the name of the Parasoft configuration file.  Default is ".psrc".
dnl   If you have your own .psrc-type file, specify here a name that will not
dnl   conflict with yours.  If you use the generated .psrc.in file, be sure
dnl   to put in in AC_OUTPUT so its .psrc counterpart is generated by
dnl   configure.
dnl   NOTE: this does not currently work due to a problem with automake-1.5.
dnl   Whatever you put for argument 1 will be ignored, but I want to keep
dnl   that position for when automake changes.  Meanwhile, the script
dnl   name will be '.psrc'.
dnl

dnl Whether insure overrides the compiler names.
AC_ARG_ENABLE(insure-as-compiler,
[  --enable-insure-as-compiler[[=COMPILERS]]
			Overide the compiler named in COMPILERS, with
			Parasoft's insure.  The names of the chosen
			compiler are placed in the Parasoft .psrc
			configuration file.  COMPILERS defaults to
			CC,CXX if omitted.],
[case "$enable_insure_as_compiler" in
  yes) enable_insure_as_compiler='CC CXX' ;;	# Override compilers.
  no) enable_insure_as_compiler= ;;		# Override no compiler.
  *)
    # Override specified compilers.
    # We allow specifications to be space- or comma-separated,
    # but remove the commas.
    enable_insure_as_compiler=`echo $enable_insure_as_compiler | sed 's/[[ 	,]]\{1,\}/ /g'`
  ;;
esac]
,
enable_insure_as_compiler=
)

dnl Specify the insure binary.
AC_ARG_WITH(insure,
[  --with-insure=PATH	Specify the name of the Parasoft insure memory
			checking program.],
INSURE_BIN=$with_insure)
if test -z "${INSURE_BIN}" ; then
  AC_PATH_PROG(INSURE_BIN,insure,insure)
fi
AC_SUBST(INSURE_BIN)


BTNG_AC_LOG_VAR(enable_insure_as_compiler INSURE_BIN)


dnl Developers may wish to know what the compilers are before overrriding.
# Define compiler names without insure.
for i in CC CXX; do
  eval "${i}_WITHOUT_INSURE=\$${i};"
done
BTNG_AC_LOG_VAR(CC_WITHOUT_INSURE CXX_WITHOUT_INSURE CC CXX)
AC_SUBST(CC_WITHOUT_INSURE)
AC_SUBST(CXX_WITHOUT_INSURE)


dnl Define macro psrc_fn to be the base name of the
dnl file the user wants to use for the Parasoft configuration
dnl file.  The default name is ".psrc"
ifelse($1,,[
define([psrc_fn],.psrc)
define([psrc_fn_in],.psrc.in)
],[
changequote(`,')
define(`psrc_fn',regexp($1,`\([^:]+\)\(:\([^:]+\)\)?$',\1))
define(`psrc_fn_in',regexp($1,`\([^:]+\)\(:\([^:]+\)\)?$',\3))
changequote([,])
ifelse(psrc_fn_in,,[ define([psrc_fn_in],psrc_fn.in) ])
])
dnl Create the configured file from its .in version.
dnl AC_CONFIG_FILES(psrc_fn[:]psrc_fn_in)
dnl IMPORTANT NOTE:
dnl Using the defined symbol btng_serpa_run_fn in AC_CONFIG_FILES
dnl causes automake to complain that btng_serpa_run_fn.in is not found,
dnl or misparse the name of the file.
dnl Since that symbol is a defined m4 macro, this is an automake deficiency.
dnl Until this is fixed, the above AC_CONFIG_FILES usage will not
dnl work!  You must call AC_CONFIG_FILES with the actual names of
dnl the file instead of the m4-defined symbol btng_serpa_run_fn.



btng_insure_psrc_fn='psrc_fn'


dnl Create .psrc.in file (at autoconf time, before configure time)
syscmd([cat <<__EOM__> ]psrc_fn_in[
# This is ]psrc_fn_in[, a template (.in file) for the
# Parasoft insure configuration file ]psrc_fn[.
# This file is generated by autoconf through the use of
# the BTNG_SUPPORT_INSURE autoconf macro.
#
# It is intended for generating the ]psrc_fn[ file at configure time.

# Set the C compiler to the value chosen at configure time.
insure++.compiler_c @CC_WITHOUT_INSURE@

# Set the C++ compiler to the value chosen at configure time.
insure++.compiler_cpp @CXX_WITHOUT_INSURE@

__EOM__
])


if test -n "${enable_insure_as_compiler}"; then
  # User wants to override the compiler names with the insure binary.


  # Define variable INSURE_AUTO_PSRC_DIRS to be
  # the directories where psrc_fn files need to be.
  INSURE_AUTO_PSRC_DIRS='esyscmd(
  for i in `find . -type d -print`; do
  test "`echo $i/*.[[Cc]] $i/*.cc $i/*.cxx $i/*.cpp $i/*.c++`" = \
             "$i/*.[[Cc]] $i/*.cc $i/*.cxx $i/*.cpp $i/*.c++" && continue
  echo $i | sed 's:^./::'
  done | sort)'
  # Remove new-line characters from system command output
  # (necessary for ac_subst-ing the variable).
  INSURE_AUTO_PSRC_DIRS=`echo $INSURE_AUTO_PSRC_DIRS`
  BTNG_AC_LOG_VAR(INSURE_AUTO_PSRC_DIRS)
  AC_SUBST(INSURE_AUTO_PSRC_DIRS)


  # Create a command to clean the psrc_fn file links.
  # This command may be used in the clean rules to remove the links.
  if test -n "$INSURE_AUTO_PSRC_DIRS"; then
    btng_remove_auto_psrc_links='
echo "Removing automatically built links to .psrc";
for i in ${INSURE_AUTO_PSRC_DIRS}; do
  rm -f "$$i/.psrc";
done
'
    # Remove new-line characters from btng_remove_auto_psrc_links
    # (necessary for ac_subst-ing the variable).
    btng_remove_auto_psrc_links=`echo $btng_remove_auto_psrc_links`
  fi
  AC_SUBST(btng_remove_auto_psrc_links)


  BTNG_AC_LOG_VAR(INSURE_AUTO_PSRC_DIRS btng_remove_auto_psrc_links)


  # Override specific compiler names listed in enable_ensure_as_compiler.
  for i in $enable_insure_as_compiler; do
    BTNG_AC_LOG(Overriding $i compiler with $INSURE_BIN)
    eval "${i}='$INSURE_BIN'"
  done


  AC_CONFIG_COMMANDS([create-psrc-links],[
  # Generate the links to the top level .psrc file,
  # if the developer generated the .psrc file.
  #
  # Once the compiler names are overridden, the only way the compiling
  # process knows what actual compiler to use is for that compiler
  # to be specified in the .psrc file.  Only one such file is
  # generated at the top level.  Lower level directories that may
  # need them have links pointing to the top level version.
  #
  # Here, we generate those links.
  if test -n "$enable_insure_as_compiler"; then
    # Generate the links only if insure overrided the compiler names.
    if test -f "$btng_insure_psrc_fn"; then
      echo "creating lower-level links to $btng_insure_psrc_fn"
      if test -n "$INSURE_AUTO_PSRC_DIRS"; then
        mkdir -p $INSURE_AUTO_PSRC_DIRS;
        for i in $INSURE_AUTO_PSRC_DIRS; do
          tmp_up_dir=`echo $i | sed 's:[^/]\{1,\}:..:'g`;
          test ! -f $i/$btng_insure_psrc_fn	\
    	&& rm -f $i/$btng_insure_psrc_fn	\
    	&& ln -s $tmp_up_dir/$btng_insure_psrc_fn	\
    	  $i/$btng_insure_psrc_fn;
        done
      fi
    fi
  fi
  ],[
  # Set variables for command to generate links to the top level .psrc file.
  btng_insure_psrc_fn="${btng_insure_psrc_fn}"
  INSURE_AUTO_PSRC_DIRS="${INSURE_AUTO_PSRC_DIRS}"
  # Variable enable_insure_as_compiler is used to determine
  # whether we should create links to the top level .psre file.
  enable_insure_as_compiler="${enable_insure_as_compiler}"
  ])


fi


undefine([psrc_fn])
undefine([psrc_fn_in])


# End macro BTNG_SUPPORT_INSURE
])



AC_DEFUN(BTNG_SUPPORT_INSURE_PSRC_ADD,[
dnl Append lines to the .psrc.in file generated.
dnl This gives the configure.in writter a way
dnl to customize the .psrc file generated.
dnl
dnl Arg1: the name of the .psrc.in file.
dnl Arg2: The lines to add.
AC_REQUIRE([BTNG_SUPPORT_INSURE])
syscmd(
cat <<__EOM__>>$1
$2
__EOM__
)
])

dnl Define a macro for supporting generalized serial-parallel run.


AC_DEFUN(BTNG_SUPPORT_SERPA,[
dnl Support a generalized way to run a program in serial or parallel mode.
dnl (serpa is serial + parallel).
dnl
dnl Arg1: name (may include relative path) to give to shell script created.
dnl   If omitted, the name will be serpa-run, in the top level directory.
dnl
dnl This macro brings out an automake bug.  See "IMPORTANT NOTE:" below
dnl for comments and how to circumvent.

# Begin macro $0


# The generalized script needs to know about the system
# so it can form the appropriate parallel run command line.
AC_REQUIRE([AC_CANONICAL_TARGET])


dnl The parallel run program (usually mpirun) is hardwired for now,
dnl but it should be more flexible.
dnl I plan to eventualy use the following variable,
dnl but it is not currently used.
PARALLELRUN_PROG=mpirun
AC_SUBST(PARALLELRUN_PROG)


define(btng_serpa_run_fn,ifelse($1,,serpa-run,$1))
dnl Create serpa-run.in file (at autoconf time, before configure time)
dnl File serpa-run.in will be used at configure time to create serpa-run
dnl in the compile tree.
syscmd([ file_name=']btng_serpa_run_fn[' cat <<'__EOM__'> ${file_name}.in
#!/bin/sh

# This script runs an executable program serially or in parallel.

# The syntax for running programs in parallel differs from platform to platform,
# software to software.  This script automatically uses the correct syntax for
# the environments that it knows about.  For the environments it does not know,
# it has a default that may work.

# This script defines the set of tests to put the program through.
# This set is parametrized by these variables:
# nproc_list: space- or comma-separated list of number of processors to use.


# The name and directory of this script
# (Do not rely on existence of dirname and basename programs.)
script_name=`echo ${0} | sed -e 's:.*/::'`;
dir_name=`echo ${0} | sed -e 's:^\([^/]*\)$:./\1:' -e 's:/[^/]*$::'`;

# Define a way to gracefully die from within this script.
# The die function is similar to Perl's.
# Arguments are: <exit_value> <exit_message>
die () {
    echo "ERROR_MESSAGE_FROM ${script_name}:"
    if [ -n "${2}" ]; then echo "Error ${2}"; fi
    if [ -n "${1}" ]; then exit ${1}; fi
    exit 99
}


# When no argument is given, print the help message and exit.
if [ "${1}" = '-h' ] || [ "${1}" = '--help' ] || [ ${#} -lt 2 ] ; then
  cat <<-_EOF_
	Usage: ${script_name} <list of nproc> <program name>

	This is a generalized script to run a program in serial
	and/or parallel.

	The number of processors are given by <list of nproc>,
	which must be a comma- or space-delimited list of integers.
	Example: ${script_name} 1,2,5 parallel_program runs
	parallel_program 3 times with 1, 2 and 5 processors in turn.

	The special case of number of processors = 0 means to run serially.
	This differs from one processor in that one processor means to run
	in parallel, but with one processor.

	This script exits with an error if any instance of
	running the program fails.

	If SERPA_REDIRECT_OUTPUT_TO is defined in the environment,
	standard output of the program is redirected there.
	If SERPA_REDIRECT_ERRORS_TO is defined in the environment,
	error output of the program is redirected there.
	Outputs directly from THIS script are NOT affected
	by these environment variables.

	If SERPA_MAX_FAILS is defined, ${script_name} will
	continue until that many failures before exiting.
	The default is 1 failure (${script_name} exits on the
	first failure).  The exit value will always be the
	failure count.
	_EOF_
exit
fi


# Check the redirection environment variables.
# See the help message for how these are used.
if [ -n "${SERPA_REDIRECT_OUTPUT_TO}" ]; then
  output_redirection_string="1> ${SERPA_REDIRECT_OUTPUT_TO}"
else
  unset output_redirection_string
fi
if [ -n "${SERPA_REDIRECT_ERRORS_TO}" ]; then
  errors_redirection_string="2> ${SERPA_REDIRECT_ERRORS_TO}"
else
  unset errors_redirection_string
fi


# Save the arguments for later reference.
serpa_args="${@}"


# Get the number of processors from the first argument of this script.
nproc_list=${1}; shift;
# We allow comma-delimited lists, so we now remove those commas.
echo ${nproc_list} | grep '^[0-9 ,]\{1,\}$' > /dev/null	\
  || die 1 "Invalid number of processors list '${nproc_list}'"
nproc_list=`echo ${nproc_list} | sed 's/,/ /g'`

# Get the program name from the next argument of this script.
program=${1}; shift;
test -x ${program} || die 1 "No execute permission on '${program}'"


# Determine host name for use below.
if [ ${?}{HOST} ]; then
  HOST=`uname -n`
  export HOST
fi


# Use additional_env to specify additional environments that
# should be set before running.  Although you can, do not use
# this to set environments for programs.  It is meant to be
# environments for the parallel execution program such as
# mpirun.
additional_env=


# Variables required for using parallelrun.  These may not be needed,
# but if they are needed and unset, there will be an error.
# Some of these strings are determined at configure time.
parallelrun_prog="@PARALLELRUN_PROG@";	# Name of parallelrun program.


# Determine what platform we are on.
target_cpu=@target_cpu@
target_os=@target_os@
target_vendor=@target_vendor@


# Determine the machine file name.
serpa_machine_file='serpa.machines'


# Define a function to run a program in parallel.
# We have to do this because different environments require different syntaxes.
# The function arguments are:
#   program name
#   number of processor
#
# We define the function in a big if-else statement based on the
# target computer.  We assume that there is a one-to-one correspondence.
# If there is not, there may have to be a nested if-structure.
#
if echo "${HOST}" | grep '^blue[0-9]' > /dev/null ; then

  # For blue, a specific singleton platform.
  if [ -z "${parallelrun_prog}" ]; then	\
    die 1 "parallelrun_prog is required but undefined"; fi
  run_multiproc () {
    MP_RESD="YES"
    MP_HOSTFILE=""
    MP_EUILIB=us
    MP_EUIDEVICE=css0
    export MP_RESD MP_HOSTFILE MP_EUILIB MP_EUIDEVICE
  # IBM shell functions eat their parameters after the first assignment
  # from them so save the parameters first.
    program=${1}; nproc=${2}; shift 2
    nodes=`expr 1 + \( ${nproc} - 1 \) / 4`
    com="${additional_env} ${parallelrun_prog} ${program}"
    com="${com} -rmpool 0 -nodes ${nodes} -np ${nproc} ${@}"
    # com="${program} ${@} -procs ${nproc}"
    echo ${com}
    eval ${com} ${output_redirection_string} ${errors_redirection_string}
    return ${?}
  }

elif echo "${HOST}" | grep '^tc2k' > /dev/null ; then

  # For tc2k, a specific singleton platform (contributed by Brian Miller).
  run_multiproc () {
    com="${additional_env} prun -n ${nproc} ${program} ${@}"
    com="${program} ${@} -p ${nproc}"
    echo ${com}
    eval ${com} ${output_redirection_string} ${errors_redirection_string}
    return ${?}
  }

elif echo "${target_os}" | grep '^osf'	> /dev/null ; then

  # For Dec OSF.
  parallelrun_prog=dmpirun
  if [ -z "${parallelrun_prog}" ]; then \
    die 1 "parallelrun_prog is required but undefined"; fi
  run_multiproc () {
    com="${additional_env} dmpirun -np ${nproc} ${program} ${@}"
    echo ${com}
    eval ${com} ${output_redirection_string} ${errors_redirection_string}
    return ${?}
  }

elif echo "${target_os}" | grep '^solaris' > /dev/null	\
  || echo "${target_os}" | grep '^irix' > /dev/null	\
  || echo "${target_os}" | grep '^linux' > /dev/null	\
  ; then

  # Most platforms fall into this case.
  parallelrun_prog=mpirun
  if [ -z "${parallelrun_prog}" ]; then \
    die 1 "parallelrun_prog is required but undefined"; fi
  run_multiproc () {
    program=${1}; nproc=${2}; shift 2
    com="${additional_env} ${parallelrun_prog}"
    com="${com} -machinefile ${dir_name}/serpa.machines -np ${nproc} ${program} ${@}"
    echo ${com}
    eval ${com} ${output_redirection_string} ${errors_redirection_string}
    return ${?}
  }

else

  # Simplest case.
  # This is generic.  It may not work, but it is our best guess
  # without knowledge of the system.
  parallelrun_prog=mpirun
  run_multiproc () {
    program=${1}; nproc=${2}; shift 2
    com="${additional_env} ${program} -np ${nproc} ${@}"
    echo ${com}
    eval ${com} ${output_redirection_string} ${errors_redirection_string}
    return ${?}
  }

fi


# Initialize the failure count.
serpa_num_failures=0
test -z "${SERPA_MAX_FAILS}" && SERPA_MAX_FAILS=1

# Run the program.
for nproc in ${nproc_list}; do
  cat <<-_EOM_
	${script_name}================================================
	RUNNING: ${script_name} ${nproc} ${program} ${@}
	${script_name}::::::::::::::::::::::::::::::::::::::::::::::::
	_EOM_
  if test "${nproc}" = 0 ; then
    # Run serially.
    com="${additional_env} ${program} ${@}"
    echo "${com}"
    eval ${com} ${output_redirection_string} ${errors_redirection_string}
    exit_value=${?}
  else
    # Because parallel runs sometimes fails due to problems unrelated
    # to the program, we give it several tries before declaring failure.
    if test -z "${SERPA_PARALLEL_TRIES}"; then SERPA_PARALLEL_TRIES=1; fi
    c=1
    while test ${c} -le ${SERPA_PARALLEL_TRIES} ; do
      if test ${c} -gt 1 ; then
        echo "possibly failed.  TRY number ${c}"
      fi
      run_multiproc ${program} ${nproc} "${@}"
      exit_value=${?}
      if [ ${exit_value} = 0 ]; then
        break
      fi
      c=`expr ${c} + 1`
    done
  fi
  # Report pass or fail.
  pf_string=FAILED; test "${exit_value}" = 0 && pf_string=PASSED
  cat <<-_EOM_
	${script_name}::::::::::::::::::::::::::::::::::::::::::::::::
	${pf_string}: ${script_name} ${nproc} ${program} ${@}
	${script_name}================================================
	_EOM_
  # Count failures and possibly exit.
  if test ${exit_value} -ne 0 ; then
    serpa_num_failures=`expr ${serpa_num_failures} + 1`;
    if test ${serpa_num_failures} -eq ${SERPA_MAX_FAILS}; then
      die 1 "FAIL running ${program} with ${nproc} processors"
    fi
  fi
done

echo "${script_name} ${serpa_args} had ${serpa_num_failures} failures."
exit ${serpa_num_failures}

# End of script.
__EOM__
])dnl End of macro to create serpa-run.in


dnl Create the configured file from its .in version.
dnl AC_CONFIG_FILES( btng_serpa_run_fn, chmod +x btng_serpa_run_fn )
dnl IMPORTANT NOTE:
dnl Using the defined symbol btng_serpa_run_fn in AC_CONFIG_FILES
dnl causes automake to complain that btng_serpa_run_fn.in is not found.
dnl Since that symbol is a defined m4 macro, this is an automake deficiency.
dnl Until this is fixed, the above AC_CONFIG_FILES usage will not
dnl work!  You must call AC_CONFIG_FILES with the actual names of
dnl the file instead of the m4-defined symbol btng_serpa_run_fn.



AC_CONFIG_COMMANDS([create-serpa-machine-file],[
# Generate a machine file if needed.
if test ! -r "$serpa_machine_file" ; then
  # Set the serpa machine file name to be in the same directory as
  # the serpa-run script.
  btng_serpa_dir_name=`echo ']btng_serpa_run_fn[' | sed -e ['s:^\([^/]*\)$:./\1:'] -e ['s:/[^/]*$::']`;
  btng_serpa_machine_file="${btng_serpa_dir_name}/serpa.machines"
  hostname="`hostname`"
  cat <<-__EOF__>"$btng_serpa_machine_file"
	$hostname
	$hostname
	$hostname
	$hostname
	__EOF__
fi
],[
dnl Settings to make before running the above.
])


undefine([btng_serpa_run_fn])


# End macro $0
])dnl End BTNG_SUPPORT_SERPA macro.

