
AC_DEFUN(BTNG_TYPE_TYPENAME,[
dnl Contributed by Brian Miller.
dnl Check if the keyword typename is supported.
dnl Define C macro TYPENAME_IS_BROKEN is it is not properly supported.

# Start macro $0

AC_MSG_CHECKING(checking whether typename is broken)

AC_CACHE_VAL(btng_cv_type_typename_broken, [

  AC_LANG_SAVE
  AC_LANG_CPLUSPLUS
  AC_TRY_COMPILE(template<typename T> void foo(T inT){ typedef typename
+T::iterator iterator; }
                ,,
    # typename is not broken.
    btng_cv_type_typename_broken=no
    ,
    # typename is broken.
    btng_cv_type_typename_broken=yes
  )     dnl End AC_TRY_COMPILE call

  AC_LANG_RESTORE

])      dnl End AC_CACHE_VAL call

AC_MSG_RESULT($btng_cv_type_typename_broken)

if test "$btng_cv_type_typename_broken" = yes; then
  AC_DEFINE(TYPENAME_IS_BROKEN,1,Define if typename is not properly supported)
fi


# End macro $0

])      dnl End of BTNG_TYPE_TYPENAME definition.

