#ifndef include_setArrayData_h
#define include_setArrayData_h

#include "MultiDimArrayAccess.h"


void setArrayDataToCoordinateSum(
  double *ptr
, const int *lower
, const int *upper
, const double *xlo , const double *xhi , const double *dx
);

void setArrayDataToSinusoidal(
  MultiDimArrayAccess<double,2> &s
, const int *lower
, const int *upper
, const double *xlo , const double *xhi , const double *dx
);

void setArrayDataToSinusoidalGradient(
  double *x_ptr, double *y_ptr
, const int *lower
, const int *upper
, const double *xlo , const double *xhi , const double *dx
);

void setArrayDataToConstant(
  MultiDimArrayAccess<double,2> &s
, const int *lower, const int *upper
, const double *xlo , const double *xhi , const double *dx
, double value
);

void setArrayDataToScaled(
  MultiDimArrayAccess<double,2> &s
  , const int *lower, const int *upper
  , double factor
);

#endif	// include_setArrayData_h
