
/*!
  \file
  \brief Contains functions to convert SAMRAI arrays to
  MultiDimArrayAccess types.
*/


#include "arrayConversionX.h"
#include "MultiDimArrayAccess.h"
#include <pdat_ArrayDataX.h>

MultiDimArrayAccess<double,NDIM> arrayData2ArrayAccess (
  pdat_ArrayDataX<double> &adat
, int depth
) {
  return MultiDimArrayAccess<double,NDIM>(
	   adat.getPointer(depth)
	   , (const int*)adat.getBox().lower()
	   , (const int*)adat.getBox().upper()
	   , true
	   );
}

ConstMultiDimArrayAccess<double,NDIM> arrayData2ArrayAccess (
  const pdat_ArrayDataX<double> &adat
, int depth
) {
  return ConstMultiDimArrayAccess<double,NDIM>(
	   adat.getPointer(depth)
	   , (const int*)adat.getBox().lower()
	   , (const int*)adat.getBox().upper()
	   , true
	   );
}
