


#ifndef included_ObjectPrinting_h
#define included_ObjectPrinting_h


#include <tbox_Pointer.h>
#define tbox_Pointer tbox_Pointer
#include <hier_PatchHierarchy2.h>
#define hier_PatchHierarchyX hier_PatchHierarchy2
#include <hier_PatchLevel2.h>
#define hier_PatchLevelX hier_PatchLevel2
#include <hier_PatchData2.h>
#define hier_PatchDataX hier_PatchData2
#include <pdat_ArrayData2.h>
#define pdat_ArrayDataX pdat_ArrayData2
#include <hier_Box2.h>
#define hier_BoxX hier_Box2



/*!
  \brief Print a patch hierarchy
*/
int printObjectX(
  ostream &os
, const SAMRAI::hier_PatchHierarchyX &hierarchy
);


/*!
  \brief Print a patch level
*/
int printObjectX(
  ostream &os
, const SAMRAI::hier_PatchLevelX &level
);


/*!
  \brief Print a box
*/
int printObjectX(
  ostream &os
, const SAMRAI::hier_BoxX &box
);


/*!
  \brief Print a patch
*/
int printObjectX(
  ostream &os
, const SAMRAI::hier_PatchDataX &pdat
);


/*!
  \brief Print an array
*/
int printObjectX(
  ostream &os
, const double *a_ptr , const int *a_lower , const int *a_upper
, const int *lower=NULL
, const int *upper=NULL
);



/*!
  \brief Print an array data object
*/
template <class T>
int printObjectX(
  ostream &os
, const SAMRAI::pdat_ArrayDataX<T> &adat
);


#endif	// included_ObjectPrinting_h
